#=======================================================================================================
# Tegridy MIDI Constants module
#=======================================================================================================

Number2patch = { # General MIDI patch numbers:
                0:'Acoustic Grand',
                1:'Bright Acoustic',
                2:'Electric Grand',
                3:'Honky-Tonk',
                4:'Electric Piano 1',
                5:'Electric Piano 2',
                6:'Harpsichord',
                7:'Clav',
                8:'Celesta',
                9:'Glockenspiel',
                10:'Music Box',
                11:'Vibraphone',
                12:'Marimba',
                13:'Xylophone',
                14:'Tubular Bells',
                15:'Dulcimer',
                16:'Drawbar Organ',
                17:'Percussive Organ',
                18:'Rock Organ',
                19:'Church Organ',
                20:'Reed Organ',
                21:'Accordion',
                22:'Harmonica',
                23:'Tango Accordion',
                24:'Acoustic Guitar(nylon)',
                25:'Acoustic Guitar(steel)',
                26:'Electric Guitar(jazz)',
                27:'Electric Guitar(clean)',
                28:'Electric Guitar(muted)',
                29:'Overdriven Guitar',
                30:'Distortion Guitar',
                31:'Guitar Harmonics',
                32:'Acoustic Bass',
                33:'Electric Bass(finger)',
                34:'Electric Bass(pick)',
                35:'Fretless Bass',
                36:'Slap Bass 1',
                37:'Slap Bass 2',
                38:'Synth Bass 1',
                39:'Synth Bass 2',
                40:'Violin',
                41:'Viola',
                42:'Cello',
                43:'Contrabass',
                44:'Tremolo Strings',
                45:'Pizzicato Strings',
                46:'Orchestral Harp',
                47:'Timpani',
                48:'String Ensemble 1',
                49:'String Ensemble 2',
                50:'SynthStrings 1',
                51:'SynthStrings 2',
                52:'Choir Aahs',
                53:'Voice Oohs',
                54:'Synth Voice',
                55:'Orchestra Hit',
                56:'Trumpet',
                57:'Trombone',
                58:'Tuba',
                59:'Muted Trumpet',
                60:'French Horn',
                61:'Brass Section',
                62:'SynthBrass 1',
                63:'SynthBrass 2',
                64:'Soprano Sax',
                65:'Alto Sax',
                66:'Tenor Sax',
                67:'Baritone Sax',
                68:'Oboe',
                69:'English Horn',
                70:'Bassoon',
                71:'Clarinet',
                72:'Piccolo',
                73:'Flute',
                74:'Recorder',
                75:'Pan Flute',
                76:'Blown Bottle',
                77:'Skakuhachi',
                78:'Whistle',
                79:'Ocarina',
                80:'Lead 1 (square)',
                81:'Lead 2 (sawtooth)',
                82:'Lead 3 (calliope)',
                83:'Lead 4 (chiff)',
                84:'Lead 5 (charang)',
                85:'Lead 6 (voice)',
                86:'Lead 7 (fifths)',
                87:'Lead 8 (bass+lead)',
                88:'Pad 1 (new age)',
                89:'Pad 2 (warm)',
                90:'Pad 3 (polysynth)',
                91:'Pad 4 (choir)',
                92:'Pad 5 (bowed)',
                93:'Pad 6 (metallic)',
                94:'Pad 7 (halo)',
                95:'Pad 8 (sweep)',
                96:'FX 1 (rain)',
                97:'FX 2 (soundtrack)',
                98:'FX 3 (crystal)',
                99:'FX 4 (atmosphere)',
                100:'FX 5 (brightness)',
                101:'FX 6 (goblins)',
                102:'FX 7 (echoes)',
                103:'FX 8 (sci-fi)',
                104:'Sitar',
                105:'Banjo',
                106:'Shamisen',
                107:'Koto',
                108:'Kalimba',
                109:'Bagpipe',
                110:'Fiddle',
                111:'Shanai',
                112:'Tinkle Bell',
                113:'Agogo',
                114:'Steel Drums',
                115:'Woodblock',
                116:'Taiko Drum',
                117:'Melodic Tom',
                118:'Synth Drum',
                119:'Reverse Cymbal',
                120:'Guitar Fret Noise',
                121:'Breath Noise',
                122:'Seashore',
                123:'Bird Tweet',
                124:'Telephone Ring',
                125:'Helicopter',
                126:'Applause',
                127:'Gunshot',
                }

#===============================================================================

Notenum2percussion = { # General MIDI Percussion (on Channel 9):
                      35:'Acoustic Bass Drum',
                      36:'Bass Drum 1',
                      37:'Side Stick',
                      38:'Acoustic Snare',
                      39:'Hand Clap',
                      40:'Electric Snare',
                      41:'Low Floor Tom',
                      42:'Closed Hi-Hat',
                      43:'High Floor Tom',
                      44:'Pedal Hi-Hat',
                      45:'Low Tom',
                      46:'Open Hi-Hat',
                      47:'Low-Mid Tom',
                      48:'Hi-Mid Tom',
                      49:'Crash Cymbal 1',
                      50:'High Tom',
                      51:'Ride Cymbal 1',
                      52:'Chinese Cymbal',
                      53:'Ride Bell',
                      54:'Tambourine',
                      55:'Splash Cymbal',
                      56:'Cowbell',
                      57:'Crash Cymbal 2',
                      58:'Vibraslap',
                      59:'Ride Cymbal 2',
                      60:'Hi Bongo',
                      61:'Low Bongo',
                      62:'Mute Hi Conga',
                      63:'Open Hi Conga',
                      64:'Low Conga',
                      65:'High Timbale',
                      66:'Low Timbale',
                      67:'High Agogo',
                      68:'Low Agogo',
                      69:'Cabasa',
                      70:'Maracas',
                      71:'Short Whistle',
                      72:'Long Whistle',
                      73:'Short Guiro',
                      74:'Long Guiro',
                      75:'Claves',
                      76:'Hi Wood Block',
                      77:'Low Wood Block',
                      78:'Mute Cuica',
                      79:'Open Cuica',
                      80:'Mute Triangle',
                      81:'Open Triangle',
                      }

#===============================================================================

MIDI_Instruments_Families = {
                            0: 'Piano Family',
                            1: 'Chromatic Percussion Family',
                            2: 'Organ Family',
                            3: 'Guitar Family',
                            4: 'Bass Family',
                            5: 'Strings Family',
                            6: 'Ensemble Family',
                            7: 'Brass Family',
                            8: 'Reed Family',
                            9: 'Pipe Family',
                            10: 'Synth Lead Family',
                            11: 'Synth Pad Family',
                            12: 'Synth Effects Family',
                            13: 'Ethnic Family',
                            14: 'Percussive Family',
                            15: 'Sound Effects Family',
                            16: 'Drums Family',
                            -1: 'Unknown Family',
                            }

#===============================================================================

ALL_CHORDS_SORTED = [[0], [0, 2], [0, 3], [0, 4], [0, 2, 4], [0, 5], [0, 2, 5], [0, 3, 5], [0, 6],
                    [0, 2, 6], [0, 3, 6], [0, 4, 6], [0, 2, 4, 6], [0, 7], [0, 2, 7], [0, 3, 7],
                    [0, 4, 7], [0, 5, 7], [0, 2, 4, 7], [0, 2, 5, 7], [0, 3, 5, 7], [0, 8],
                    [0, 2, 8], [0, 3, 8], [0, 4, 8], [0, 5, 8], [0, 6, 8], [0, 2, 4, 8],
                    [0, 2, 5, 8], [0, 2, 6, 8], [0, 3, 5, 8], [0, 3, 6, 8], [0, 4, 6, 8],
                    [0, 2, 4, 6, 8], [0, 9], [0, 2, 9], [0, 3, 9], [0, 4, 9], [0, 5, 9], [0, 6, 9],
                    [0, 7, 9], [0, 2, 4, 9], [0, 2, 5, 9], [0, 2, 6, 9], [0, 2, 7, 9],
                    [0, 3, 5, 9], [0, 3, 6, 9], [0, 3, 7, 9], [0, 4, 6, 9], [0, 4, 7, 9],
                    [0, 5, 7, 9], [0, 2, 4, 6, 9], [0, 2, 4, 7, 9], [0, 2, 5, 7, 9],
                    [0, 3, 5, 7, 9], [0, 10], [0, 2, 10], [0, 3, 10], [0, 4, 10], [0, 5, 10],
                    [0, 6, 10], [0, 7, 10], [0, 8, 10], [0, 2, 4, 10], [0, 2, 5, 10],
                    [0, 2, 6, 10], [0, 2, 7, 10], [0, 2, 8, 10], [0, 3, 5, 10], [0, 3, 6, 10],
                    [0, 3, 7, 10], [0, 3, 8, 10], [0, 4, 6, 10], [0, 4, 7, 10], [0, 4, 8, 10],
                    [0, 5, 7, 10], [0, 5, 8, 10], [0, 6, 8, 10], [0, 2, 4, 6, 10],
                    [0, 2, 4, 7, 10], [0, 2, 4, 8, 10], [0, 2, 5, 7, 10], [0, 2, 5, 8, 10],
                    [0, 2, 6, 8, 10], [0, 3, 5, 7, 10], [0, 3, 5, 8, 10], [0, 3, 6, 8, 10],
                    [0, 4, 6, 8, 10], [0, 2, 4, 6, 8, 10], [1], [1, 3], [1, 4], [1, 5], [1, 3, 5],
                    [1, 6], [1, 3, 6], [1, 4, 6], [1, 7], [1, 3, 7], [1, 4, 7], [1, 5, 7],
                    [1, 3, 5, 7], [1, 8], [1, 3, 8], [1, 4, 8], [1, 5, 8], [1, 6, 8], [1, 3, 5, 8],
                    [1, 3, 6, 8], [1, 4, 6, 8], [1, 9], [1, 3, 9], [1, 4, 9], [1, 5, 9], [1, 6, 9],
                    [1, 7, 9], [1, 3, 5, 9], [1, 3, 6, 9], [1, 3, 7, 9], [1, 4, 6, 9],
                    [1, 4, 7, 9], [1, 5, 7, 9], [1, 3, 5, 7, 9], [1, 10], [1, 3, 10], [1, 4, 10],
                    [1, 5, 10], [1, 6, 10], [1, 7, 10], [1, 8, 10], [1, 3, 5, 10], [1, 3, 6, 10],
                    [1, 3, 7, 10], [1, 3, 8, 10], [1, 4, 6, 10], [1, 4, 7, 10], [1, 4, 8, 10],
                    [1, 5, 7, 10], [1, 5, 8, 10], [1, 6, 8, 10], [1, 3, 5, 7, 10],
                    [1, 3, 5, 8, 10], [1, 3, 6, 8, 10], [1, 4, 6, 8, 10], [1, 11], [1, 3, 11],
                    [1, 4, 11], [1, 5, 11], [1, 6, 11], [1, 7, 11], [1, 8, 11], [1, 9, 11],
                    [1, 3, 5, 11], [1, 3, 6, 11], [1, 3, 7, 11], [1, 3, 8, 11], [1, 3, 9, 11],
                    [1, 4, 6, 11], [1, 4, 7, 11], [1, 4, 8, 11], [1, 4, 9, 11], [1, 5, 7, 11],
                    [1, 5, 8, 11], [1, 5, 9, 11], [1, 6, 8, 11], [1, 6, 9, 11], [1, 7, 9, 11],
                    [1, 3, 5, 7, 11], [1, 3, 5, 8, 11], [1, 3, 5, 9, 11], [1, 3, 6, 8, 11],
                    [1, 3, 6, 9, 11], [1, 3, 7, 9, 11], [1, 4, 6, 8, 11], [1, 4, 6, 9, 11],
                    [1, 4, 7, 9, 11], [1, 5, 7, 9, 11], [1, 3, 5, 7, 9, 11], [2], [2, 4], [2, 5],
                    [2, 6], [2, 4, 6], [2, 7], [2, 4, 7], [2, 5, 7], [2, 8], [2, 4, 8], [2, 5, 8],
                    [2, 6, 8], [2, 4, 6, 8], [2, 9], [2, 4, 9], [2, 5, 9], [2, 6, 9], [2, 7, 9],
                    [2, 4, 6, 9], [2, 4, 7, 9], [2, 5, 7, 9], [2, 10], [2, 4, 10], [2, 5, 10],
                    [2, 6, 10], [2, 7, 10], [2, 8, 10], [2, 4, 6, 10], [2, 4, 7, 10],
                    [2, 4, 8, 10], [2, 5, 7, 10], [2, 5, 8, 10], [2, 6, 8, 10], [2, 4, 6, 8, 10],
                    [2, 11], [2, 4, 11], [2, 5, 11], [2, 6, 11], [2, 7, 11], [2, 8, 11],
                    [2, 9, 11], [2, 4, 6, 11], [2, 4, 7, 11], [2, 4, 8, 11], [2, 4, 9, 11],
                    [2, 5, 7, 11], [2, 5, 8, 11], [2, 5, 9, 11], [2, 6, 8, 11], [2, 6, 9, 11],
                    [2, 7, 9, 11], [2, 4, 6, 8, 11], [2, 4, 6, 9, 11], [2, 4, 7, 9, 11],
                    [2, 5, 7, 9, 11], [3], [3, 5], [3, 6], [3, 7], [3, 5, 7], [3, 8], [3, 5, 8],
                    [3, 6, 8], [3, 9], [3, 5, 9], [3, 6, 9], [3, 7, 9], [3, 5, 7, 9], [3, 10],
                    [3, 5, 10], [3, 6, 10], [3, 7, 10], [3, 8, 10], [3, 5, 7, 10], [3, 5, 8, 10],
                    [3, 6, 8, 10], [3, 11], [3, 5, 11], [3, 6, 11], [3, 7, 11], [3, 8, 11],
                    [3, 9, 11], [3, 5, 7, 11], [3, 5, 8, 11], [3, 5, 9, 11], [3, 6, 8, 11],
                    [3, 6, 9, 11], [3, 7, 9, 11], [3, 5, 7, 9, 11], [4], [4, 6], [4, 7], [4, 8],
                    [4, 6, 8], [4, 9], [4, 6, 9], [4, 7, 9], [4, 10], [4, 6, 10], [4, 7, 10],
                    [4, 8, 10], [4, 6, 8, 10], [4, 11], [4, 6, 11], [4, 7, 11], [4, 8, 11],
                    [4, 9, 11], [4, 6, 8, 11], [4, 6, 9, 11], [4, 7, 9, 11], [5], [5, 7], [5, 8],
                    [5, 9], [5, 7, 9], [5, 10], [5, 7, 10], [5, 8, 10], [5, 11], [5, 7, 11],
                    [5, 8, 11], [5, 9, 11], [5, 7, 9, 11], [6], [6, 8], [6, 9], [6, 10],
                    [6, 8, 10], [6, 11], [6, 8, 11], [6, 9, 11], [7], [7, 9], [7, 10], [7, 11],
                    [7, 9, 11], [8], [8, 10], [8, 11], [9], [9, 11], [10], [11]]

#===============================================================================

ALL_CHORDS = [[0], [7], [5], [9], [2], [4], [11], [10], [8], [6], [3], [1], [0, 9], [2, 5],
              [4, 7], [7, 10], [2, 11], [0, 3], [6, 9], [1, 4], [8, 11], [5, 8], [1, 10],
              [3, 6], [0, 4], [5, 9], [7, 11], [0, 7], [0, 5], [2, 10], [2, 7], [2, 9],
              [2, 6], [4, 11], [4, 9], [3, 7], [5, 10], [1, 9], [0, 8], [6, 11], [3, 11],
              [4, 8], [3, 10], [3, 8], [1, 5], [1, 8], [1, 6], [6, 10], [3, 9], [4, 10],
              [1, 7], [0, 6], [2, 8], [5, 11], [5, 7], [0, 10], [0, 2], [9, 11], [7, 9],
              [2, 4], [4, 6], [3, 5], [8, 10], [6, 8], [1, 3], [1, 11], [2, 7, 11],
              [0, 4, 7], [0, 5, 9], [2, 6, 9], [2, 5, 10], [1, 4, 9], [4, 8, 11], [3, 7, 10],
              [0, 3, 8], [3, 6, 11], [1, 5, 8], [1, 6, 10], [0, 4, 9], [2, 5, 9], [4, 7, 11],
              [2, 7, 10], [2, 6, 11], [0, 3, 7], [0, 5, 8], [1, 4, 8], [1, 6, 9], [3, 8, 11],
              [1, 5, 10], [3, 6, 10], [2, 5, 11], [4, 7, 10], [3, 6, 9], [0, 6, 9],
              [0, 3, 9], [2, 8, 11], [2, 5, 8], [1, 7, 10], [1, 4, 7], [0, 3, 6], [1, 4, 10],
              [5, 8, 11], [2, 5, 7], [0, 7, 10], [0, 2, 9], [0, 3, 5], [6, 9, 11], [4, 7, 9],
              [2, 4, 11], [5, 8, 10], [1, 3, 10], [1, 4, 6], [3, 6, 8], [1, 8, 11],
              [5, 7, 11], [0, 4, 10], [3, 5, 9], [0, 2, 6], [1, 7, 9], [0, 7, 9], [5, 7, 10],
              [2, 8, 10], [3, 9, 11], [0, 2, 5], [2, 4, 8], [2, 4, 7], [0, 2, 7], [2, 7, 9],
              [4, 9, 11], [4, 6, 9], [1, 3, 7], [2, 4, 9], [0, 5, 7], [0, 3, 10], [2, 9, 11],
              [0, 5, 10], [0, 6, 8], [4, 6, 10], [4, 6, 11], [1, 4, 11], [6, 8, 11],
              [1, 5, 11], [1, 6, 11], [1, 8, 10], [1, 6, 8], [3, 5, 8], [3, 8, 10],
              [1, 3, 8], [3, 5, 10], [1, 3, 6], [2, 5, 7, 10], [0, 3, 7, 10], [1, 4, 8, 11],
              [2, 4, 7, 11], [0, 4, 7, 9], [0, 2, 5, 9], [2, 6, 9, 11], [1, 5, 8, 10],
              [0, 3, 5, 8], [3, 6, 8, 11], [1, 3, 6, 10], [1, 4, 6, 9], [1, 5, 9], [0, 4, 8],
              [2, 6, 10], [3, 7, 11], [0, 3, 6, 9], [2, 5, 8, 11], [1, 4, 7, 10],
              [2, 5, 7, 11], [0, 2, 6, 9], [0, 4, 7, 10], [2, 4, 8, 11], [0, 3, 5, 9],
              [1, 4, 7, 9], [3, 6, 9, 11], [2, 5, 8, 10], [1, 4, 6, 10], [0, 3, 6, 8],
              [1, 3, 7, 10], [1, 5, 8, 11], [2, 4, 10], [5, 9, 11], [1, 5, 7], [0, 2, 8],
              [0, 4, 6], [1, 7, 11], [3, 7, 9], [1, 3, 9], [7, 9, 11], [5, 7, 9], [0, 6, 10],
              [0, 2, 10], [2, 6, 8], [0, 2, 4], [4, 8, 10], [1, 9, 11], [2, 4, 6],
              [3, 5, 11], [3, 5, 7], [0, 8, 10], [4, 6, 8], [1, 3, 11], [6, 8, 10],
              [1, 3, 5], [0, 2, 5, 10], [0, 5, 7, 9], [0, 3, 8, 10], [0, 2, 4, 7],
              [4, 6, 8, 11], [3, 5, 7, 10], [2, 7, 9, 11], [2, 4, 6, 9], [1, 6, 8, 10],
              [1, 4, 9, 11], [1, 3, 5, 8], [1, 3, 6, 11], [2, 5, 9, 11], [2, 4, 7, 10],
              [0, 2, 5, 8], [1, 5, 7, 10], [0, 4, 6, 9], [1, 3, 6, 9], [0, 3, 6, 10],
              [2, 6, 8, 11], [0, 2, 7, 9], [1, 4, 8, 10], [0, 3, 7, 9], [3, 5, 8, 11],
              [0, 5, 7, 10], [0, 2, 5, 7], [1, 4, 7, 11], [2, 4, 7, 9], [0, 3, 5, 10],
              [4, 6, 9, 11], [1, 4, 6, 11], [2, 4, 9, 11], [1, 6, 8, 11], [1, 3, 6, 8],
              [1, 3, 8, 10], [3, 5, 8, 10], [4, 7, 9, 11], [0, 2, 7, 10], [2, 5, 7, 9],
              [0, 2, 4, 9], [1, 6, 9, 11], [2, 4, 6, 11], [0, 3, 5, 7], [0, 5, 8, 10],
              [1, 4, 6, 8], [1, 3, 5, 10], [1, 3, 8, 11], [3, 6, 8, 10], [0, 2, 5, 7, 10],
              [0, 2, 4, 7, 9], [0, 2, 5, 7, 9], [1, 3, 7, 9], [1, 4, 6, 9, 11],
              [1, 3, 6, 8, 11], [3, 5, 9, 11], [1, 3, 6, 8, 10], [1, 4, 6, 8, 11],
              [1, 3, 5, 8, 10], [2, 4, 6, 9, 11], [2, 4, 8, 10], [2, 4, 7, 9, 11],
              [0, 3, 5, 7, 10], [1, 5, 7, 11], [0, 2, 6, 8], [0, 3, 5, 8, 10], [0, 4, 6, 10],
              [1, 3, 5, 9], [1, 5, 7, 9], [2, 6, 8, 10], [3, 7, 9, 11], [0, 2, 4, 8],
              [0, 4, 6, 8], [0, 4, 8, 10], [2, 4, 6, 10], [1, 3, 7, 11], [0, 2, 6, 10],
              [1, 5, 9, 11], [3, 5, 7, 11], [1, 7, 9, 11], [0, 2, 4, 6], [1, 3, 9, 11],
              [0, 2, 4, 10], [5, 7, 9, 11], [2, 4, 6, 8], [0, 2, 8, 10], [3, 5, 7, 9],
              [1, 3, 5, 7], [4, 6, 8, 10], [0, 6, 8, 10], [1, 3, 5, 11], [0, 3, 6, 8, 10],
              [0, 2, 4, 6, 9], [1, 4, 7, 9, 11], [2, 4, 6, 8, 11], [1, 3, 6, 9, 11],
              [1, 3, 5, 8, 11], [0, 2, 5, 8, 10], [1, 4, 6, 8, 10], [0, 3, 5, 7, 9],
              [2, 5, 7, 9, 11], [1, 3, 5, 7, 10], [0, 2, 4, 7, 10], [1, 3, 5, 7, 9],
              [1, 3, 5, 9, 11], [1, 5, 7, 9, 11], [1, 3, 7, 9, 11], [3, 5, 7, 9, 11],
              [2, 4, 6, 8, 10], [0, 4, 6, 8, 10], [0, 2, 6, 8, 10], [1, 3, 5, 7, 11],
              [0, 2, 4, 8, 10], [0, 2, 4, 6, 8], [0, 2, 4, 6, 10], [0, 2, 4, 6, 8, 10],
              [1, 3, 5, 7, 9, 11]]

#===============================================================================

ALL_CHORDS_GROUPED = [[[0], [1], [2], [3], [4], [5], [6], [7], [8], [9], [10], [11]],
                      [[0, 2], [0, 3], [0, 4], [0, 5], [0, 6], [0, 7], [0, 8], [0, 9], [0, 10],
                        [1, 3], [1, 4], [1, 5], [1, 6], [1, 7], [1, 8], [1, 9], [1, 10], [1, 11],
                        [2, 4], [2, 5], [2, 6], [2, 7], [2, 8], [2, 9], [2, 10], [2, 11], [3, 5],
                        [3, 6], [3, 7], [3, 8], [3, 9], [3, 10], [3, 11], [4, 6], [4, 7], [4, 8],
                        [4, 9], [4, 10], [4, 11], [5, 7], [5, 8], [5, 9], [5, 10], [5, 11], [6, 8],
                        [6, 9], [6, 10], [6, 11], [7, 9], [7, 10], [7, 11], [8, 10], [8, 11],
                        [9, 11]],
                      [[0, 2, 4], [0, 2, 5], [0, 3, 5], [0, 2, 6], [0, 3, 6], [0, 4, 6], [0, 2, 7],
                        [0, 3, 7], [0, 4, 7], [0, 5, 7], [0, 2, 8], [0, 3, 8], [0, 4, 8], [0, 5, 8],
                        [0, 6, 8], [0, 2, 9], [0, 3, 9], [0, 4, 9], [0, 5, 9], [0, 6, 9], [0, 7, 9],
                        [0, 2, 10], [0, 3, 10], [0, 4, 10], [0, 5, 10], [0, 6, 10], [0, 7, 10],
                        [0, 8, 10], [1, 3, 5], [1, 3, 6], [1, 4, 6], [1, 3, 7], [1, 4, 7], [1, 5, 7],
                        [1, 3, 8], [1, 4, 8], [1, 5, 8], [1, 6, 8], [1, 3, 9], [1, 4, 9], [1, 5, 9],
                        [1, 6, 9], [1, 7, 9], [1, 3, 10], [1, 4, 10], [1, 5, 10], [1, 6, 10],
                        [1, 7, 10], [1, 8, 10], [1, 3, 11], [1, 4, 11], [1, 5, 11], [1, 6, 11],
                        [1, 7, 11], [1, 8, 11], [1, 9, 11], [2, 4, 6], [2, 4, 7], [2, 5, 7],
                        [2, 4, 8], [2, 5, 8], [2, 6, 8], [2, 4, 9], [2, 5, 9], [2, 6, 9], [2, 7, 9],
                        [2, 4, 10], [2, 5, 10], [2, 6, 10], [2, 7, 10], [2, 8, 10], [2, 4, 11],
                        [2, 5, 11], [2, 6, 11], [2, 7, 11], [2, 8, 11], [2, 9, 11], [3, 5, 7],
                        [3, 5, 8], [3, 6, 8], [3, 5, 9], [3, 6, 9], [3, 7, 9], [3, 5, 10], [3, 6, 10],
                        [3, 7, 10], [3, 8, 10], [3, 5, 11], [3, 6, 11], [3, 7, 11], [3, 8, 11],
                        [3, 9, 11], [4, 6, 8], [4, 6, 9], [4, 7, 9], [4, 6, 10], [4, 7, 10],
                        [4, 8, 10], [4, 6, 11], [4, 7, 11], [4, 8, 11], [4, 9, 11], [5, 7, 9],
                        [5, 7, 10], [5, 8, 10], [5, 7, 11], [5, 8, 11], [5, 9, 11], [6, 8, 10],
                        [6, 8, 11], [6, 9, 11], [7, 9, 11]],
                      [[0, 2, 4, 6], [0, 2, 4, 7], [0, 2, 5, 7], [0, 3, 5, 7], [0, 2, 4, 8],
                        [0, 2, 5, 8], [0, 2, 6, 8], [0, 3, 5, 8], [0, 3, 6, 8], [0, 4, 6, 8],
                        [0, 2, 4, 9], [0, 2, 5, 9], [0, 2, 6, 9], [0, 2, 7, 9], [0, 3, 5, 9],
                        [0, 3, 6, 9], [0, 3, 7, 9], [0, 4, 6, 9], [0, 4, 7, 9], [0, 5, 7, 9],
                        [0, 2, 4, 10], [0, 2, 5, 10], [0, 2, 6, 10], [0, 2, 7, 10], [0, 2, 8, 10],
                        [0, 3, 5, 10], [0, 3, 6, 10], [0, 3, 7, 10], [0, 3, 8, 10], [0, 4, 6, 10],
                        [0, 4, 7, 10], [0, 4, 8, 10], [0, 5, 7, 10], [0, 5, 8, 10], [0, 6, 8, 10],
                        [1, 3, 5, 7], [1, 3, 5, 8], [1, 3, 6, 8], [1, 4, 6, 8], [1, 3, 5, 9],
                        [1, 3, 6, 9], [1, 3, 7, 9], [1, 4, 6, 9], [1, 4, 7, 9], [1, 5, 7, 9],
                        [1, 3, 5, 10], [1, 3, 6, 10], [1, 3, 7, 10], [1, 3, 8, 10], [1, 4, 6, 10],
                        [1, 4, 7, 10], [1, 4, 8, 10], [1, 5, 7, 10], [1, 5, 8, 10], [1, 6, 8, 10],
                        [1, 3, 5, 11], [1, 3, 6, 11], [1, 3, 7, 11], [1, 3, 8, 11], [1, 3, 9, 11],
                        [1, 4, 6, 11], [1, 4, 7, 11], [1, 4, 8, 11], [1, 4, 9, 11], [1, 5, 7, 11],
                        [1, 5, 8, 11], [1, 5, 9, 11], [1, 6, 8, 11], [1, 6, 9, 11], [1, 7, 9, 11],
                        [2, 4, 6, 8], [2, 4, 6, 9], [2, 4, 7, 9], [2, 5, 7, 9], [2, 4, 6, 10],
                        [2, 4, 7, 10], [2, 4, 8, 10], [2, 5, 7, 10], [2, 5, 8, 10], [2, 6, 8, 10],
                        [2, 4, 6, 11], [2, 4, 7, 11], [2, 4, 8, 11], [2, 4, 9, 11], [2, 5, 7, 11],
                        [2, 5, 8, 11], [2, 5, 9, 11], [2, 6, 8, 11], [2, 6, 9, 11], [2, 7, 9, 11],
                        [3, 5, 7, 9], [3, 5, 7, 10], [3, 5, 8, 10], [3, 6, 8, 10], [3, 5, 7, 11],
                        [3, 5, 8, 11], [3, 5, 9, 11], [3, 6, 8, 11], [3, 6, 9, 11], [3, 7, 9, 11],
                        [4, 6, 8, 10], [4, 6, 8, 11], [4, 6, 9, 11], [4, 7, 9, 11], [5, 7, 9, 11]],
                      [[0, 2, 4, 6, 8], [0, 2, 4, 6, 9], [0, 2, 4, 7, 9], [0, 2, 5, 7, 9],
                        [0, 3, 5, 7, 9], [0, 2, 4, 6, 10], [0, 2, 4, 7, 10], [0, 2, 4, 8, 10],
                        [0, 2, 5, 7, 10], [0, 2, 5, 8, 10], [0, 2, 6, 8, 10], [0, 3, 5, 7, 10],
                        [0, 3, 5, 8, 10], [0, 3, 6, 8, 10], [0, 4, 6, 8, 10], [1, 3, 5, 7, 9],
                        [1, 3, 5, 7, 10], [1, 3, 5, 8, 10], [1, 3, 6, 8, 10], [1, 4, 6, 8, 10],
                        [1, 3, 5, 7, 11], [1, 3, 5, 8, 11], [1, 3, 5, 9, 11], [1, 3, 6, 8, 11],
                        [1, 3, 6, 9, 11], [1, 3, 7, 9, 11], [1, 4, 6, 8, 11], [1, 4, 6, 9, 11],
                        [1, 4, 7, 9, 11], [1, 5, 7, 9, 11], [2, 4, 6, 8, 10], [2, 4, 6, 8, 11],
                        [2, 4, 6, 9, 11], [2, 4, 7, 9, 11], [2, 5, 7, 9, 11], [3, 5, 7, 9, 11]],
                      [[0, 2, 4, 6, 8, 10], [1, 3, 5, 7, 9, 11]]]

#===============================================================================

ALL_CHORDS_FILTERED = [[0], [0, 3], [0, 3, 5], [0, 3, 5, 8], [0, 3, 5, 9], [0, 3, 5, 10], [0, 3, 7],
                      [0, 3, 7, 10], [0, 3, 8], [0, 3, 9], [0, 3, 10], [0, 4], [0, 4, 6],
                      [0, 4, 6, 9], [0, 4, 6, 10], [0, 4, 7], [0, 4, 7, 10], [0, 4, 8], [0, 4, 9],
                      [0, 4, 10], [0, 5], [0, 5, 8], [0, 5, 9], [0, 5, 10], [0, 6], [0, 6, 9],
                      [0, 6, 10], [0, 7], [0, 7, 10], [0, 8], [0, 9], [0, 10], [1], [1, 4],
                      [1, 4, 6], [1, 4, 6, 9], [1, 4, 6, 10], [1, 4, 6, 11], [1, 4, 7],
                      [1, 4, 7, 10], [1, 4, 7, 11], [1, 4, 8], [1, 4, 8, 11], [1, 4, 9], [1, 4, 10],
                      [1, 4, 11], [1, 5], [1, 5, 8], [1, 5, 8, 11], [1, 5, 9], [1, 5, 10],
                      [1, 5, 11], [1, 6], [1, 6, 9], [1, 6, 10], [1, 6, 11], [1, 7], [1, 7, 10],
                      [1, 7, 11], [1, 8], [1, 8, 11], [1, 9], [1, 10], [1, 11], [2], [2, 5],
                      [2, 5, 8], [2, 5, 8, 11], [2, 5, 9], [2, 5, 10], [2, 5, 11], [2, 6], [2, 6, 9],
                      [2, 6, 10], [2, 6, 11], [2, 7], [2, 7, 10], [2, 7, 11], [2, 8], [2, 8, 11],
                      [2, 9], [2, 10], [2, 11], [3], [3, 5], [3, 5, 8], [3, 5, 8, 11], [3, 5, 9],
                      [3, 5, 10], [3, 5, 11], [3, 7], [3, 7, 10], [3, 7, 11], [3, 8], [3, 8, 11],
                      [3, 9], [3, 10], [3, 11], [4], [4, 6], [4, 6, 9], [4, 6, 10], [4, 6, 11],
                      [4, 7], [4, 7, 10], [4, 7, 11], [4, 8], [4, 8, 11], [4, 9], [4, 10], [4, 11],
                      [5], [5, 8], [5, 8, 11], [5, 9], [5, 10], [5, 11], [6], [6, 9], [6, 10],
                      [6, 11], [7], [7, 10], [7, 11], [8], [8, 11], [9], [10], [11]]

#===============================================================================

ALL_PITCHES_CHORDS_FILTERED = [[67], [64], [62], [69], [60], [65], [59], [70], [66], [63], [68], [61],
                              [64, 60], [67, 64], [65, 62], [62, 59], [69, 65], [60, 57], [66, 62], [59, 55],
                              [62, 57], [67, 62], [64, 59], [64, 60, 55], [60, 55], [65, 60], [64, 61],
                              [69, 64], [66, 62, 57], [69, 66], [62, 59, 55], [64, 60, 57], [62, 58],
                              [65, 60, 57], [70, 67], [67, 63], [64, 61, 57], [61, 57], [63, 60], [68, 64],
                              [65, 62, 58], [65, 62, 57], [59, 56], [63, 58], [68, 65], [59, 54, 47, 35],
                              [70, 65], [66, 61], [64, 59, 56], [65, 61], [64, 59, 55], [63, 59], [61, 58],
                              [68, 63], [60, 56], [67, 63, 60], [67, 63, 58], [66, 62, 59], [61, 56],
                              [70, 66], [67, 62, 58], [63, 60, 56], [65, 61, 56], [66, 61, 58], [66, 61, 57],
                              [65, 60, 56], [65, 61, 58], [65, 59], [68, 64, 61], [66, 60], [64, 58],
                              [62, 56], [63, 57], [61, 55], [66, 64], [60, 58], [65, 63], [63, 59, 56],
                              [65, 62, 59], [61, 59], [66, 60, 57], [64, 61, 55], [64, 58, 55], [62, 59, 56],
                              [64, 60, 58], [63, 60, 57], [64, 60, 58, 55], [65, 62, 56], [64, 61, 58],
                              [66, 64, 59], [60, 58, 55], [65, 63, 60], [63, 57, 53], [65, 63, 60, 57],
                              [65, 59, 56], [63, 60, 58, 55], [67, 61, 58], [64, 61, 57, 54], [64, 61, 59],
                              [70, 65, 60], [68, 65, 63, 60], [63, 60, 58], [65, 63, 58], [69, 66, 64],
                              [64, 60, 54], [64, 60, 57, 54], [66, 64, 61], [66, 61, 59], [67, 63, 59],
                              [65, 61, 57], [68, 65, 63], [64, 61, 59, 56], [65, 61, 59], [66, 64, 61, 58],
                              [64, 61, 58, 55], [64, 60, 56], [65, 61, 59, 56], [66, 62, 58], [61, 59, 56],
                              [64, 58, 54], [63, 59, 53], [65, 62, 59, 56], [61, 59, 55], [64, 61, 59, 55],
                              [68, 65, 63, 59], [70, 66, 60], [65, 63, 60, 58], [64, 61, 59, 54],
                              [70, 64, 60, 54]]

#===============================================================================

ALL_PITCHES_CHORDS_SORTED = [[60], [62, 60], [63, 60], [64, 60], [64, 62, 60], [65, 60], [65, 62, 60],
                            [65, 63, 60], [66, 60], [66, 62, 60], [66, 63, 60], [64, 60, 54],
                            [64, 60, 54, 50], [60, 55], [67, 62, 60], [67, 63, 60], [64, 60, 55],
                            [65, 60, 55], [64, 62, 60, 55], [67, 65, 62, 60], [67, 65, 63, 60], [60, 56],
                            [62, 60, 56], [63, 60, 56], [64, 60, 56], [65, 60, 56], [66, 60, 56],
                            [72, 68, 64, 62], [65, 62, 60, 56], [66, 62, 60, 56], [68, 65, 63, 60],
                            [68, 66, 63, 60], [60, 44, 42, 40], [88, 80, 74, 66, 60, 56], [60, 57],
                            [62, 60, 57], [63, 60, 57], [64, 60, 57], [65, 60, 57], [66, 60, 57],
                            [67, 60, 57], [64, 62, 60, 57], [65, 62, 60, 57], [69, 66, 62, 60],
                            [67, 62, 60, 57], [65, 63, 60, 57], [66, 63, 60, 57], [67, 63, 60, 57],
                            [64, 60, 57, 54], [67, 64, 60, 57], [67, 65, 60, 57], [69, 64, 60, 54, 38],
                            [67, 64, 62, 60, 57], [67, 65, 62, 60, 57], [67, 65, 63, 60, 57], [60, 58],
                            [62, 60, 58], [63, 60, 58], [64, 60, 58], [70, 65, 60], [70, 66, 60],
                            [60, 58, 55], [70, 60, 56], [74, 64, 60, 58], [65, 62, 60, 58],
                            [70, 66, 62, 60], [62, 60, 58, 55], [72, 68, 62, 58], [65, 63, 60, 58],
                            [70, 66, 63, 60], [63, 60, 58, 55], [70, 63, 60, 56], [70, 64, 60, 54],
                            [64, 60, 58, 55], [68, 64, 60, 58], [65, 60, 58, 55], [70, 65, 60, 56],
                            [70, 66, 60, 56], [78, 76, 74, 72, 70, 66], [67, 64, 62, 58, 36],
                            [74, 68, 64, 58, 48], [65, 62, 58, 55, 36], [65, 62, 60, 56, 46],
                            [72, 66, 62, 56, 46], [79, 65, 63, 58, 53, 36], [65, 60, 56, 51, 46, 41],
                            [70, 66, 63, 60, 44], [68, 66, 64, 58, 56, 48],
                            [94, 92, 90, 88, 86, 84, 82, 80, 78, 76, 74, 72, 70, 68, 66, 64, 62, 60, 58,
                              56, 54, 52, 50, 48, 46, 44, 42, 40, 38, 36, 34, 32, 30, 28, 26, 24],
                            [61], [63, 61], [64, 61], [65, 61], [65, 63, 61], [66, 61], [66, 63, 61],
                            [66, 64, 61], [61, 55], [67, 63, 61], [64, 61, 55], [65, 61, 55],
                            [65, 61, 55, 39], [61, 56], [63, 61, 56], [68, 64, 61], [65, 61, 56],
                            [66, 61, 56], [68, 65, 63, 61], [54, 49, 44, 39], [68, 64, 61, 42], [61, 57],
                            [63, 61, 57], [64, 61, 57], [65, 61, 57], [66, 61, 57], [67, 61, 57],
                            [69, 65, 63, 61], [66, 63, 61, 57], [67, 63, 61, 57], [64, 61, 57, 54],
                            [67, 64, 61, 57], [65, 61, 55, 45], [67, 65, 63, 61, 57], [61, 58],
                            [63, 61, 58], [64, 61, 58], [65, 61, 58], [66, 61, 58], [67, 61, 58],
                            [61, 58, 56], [65, 63, 61, 58], [66, 63, 61, 58], [67, 63, 61, 58],
                            [63, 61, 58, 56], [66, 64, 61, 58], [64, 61, 58, 55], [68, 64, 61, 58],
                            [65, 61, 58, 55], [65, 61, 58, 56], [58, 54, 49, 44], [70, 65, 61, 55, 39],
                            [80, 68, 65, 63, 61, 58], [63, 58, 54, 49, 44, 39], [73, 68, 64, 58, 54],
                            [61, 59], [63, 61, 59], [64, 61, 59], [65, 61, 59], [66, 61, 59], [61, 59, 55],
                            [61, 59, 56], [61, 59, 57], [63, 59, 53, 49], [66, 63, 61, 59],
                            [71, 67, 63, 61], [63, 61, 59, 56], [61, 57, 51, 47], [64, 61, 59, 54],
                            [64, 61, 59, 55], [64, 61, 59, 56], [64, 61, 59, 57], [65, 61, 59, 55],
                            [65, 61, 59, 56], [69, 65, 61, 59], [66, 61, 59, 56], [71, 66, 61, 57],
                            [71, 67, 61, 57], [67, 63, 59, 53, 49], [68, 65, 63, 59, 37],
                            [65, 63, 61, 59, 57], [66, 63, 61, 59, 56], [73, 69, 66, 63, 59],
                            [79, 75, 73, 61, 59, 33], [61, 56, 52, 47, 42, 35], [76, 73, 69, 66, 35],
                            [71, 67, 64, 61, 57], [73, 71, 69, 67, 65],
                            [95, 93, 91, 89, 87, 85, 83, 81, 79, 77, 75, 73, 71, 69, 67, 65, 63, 61, 59,
                              57, 55, 53, 51, 49, 47, 45, 43, 41, 39, 37, 35, 33, 31, 29, 27, 25],
                            [62], [64, 62], [65, 62], [66, 62], [66, 64, 62], [67, 62], [67, 64, 62],
                            [67, 65, 62], [62, 56], [68, 64, 62], [65, 62, 56], [66, 62, 56],
                            [66, 62, 56, 52], [62, 57], [50, 45, 40], [65, 62, 57], [66, 62, 57],
                            [55, 50, 45], [66, 64, 62, 57], [55, 50, 45, 40], [69, 67, 65, 62], [62, 58],
                            [64, 62, 58], [65, 62, 58], [66, 62, 58], [67, 62, 58], [62, 58, 56],
                            [66, 64, 62, 58], [67, 64, 62, 58], [64, 62, 58, 56], [65, 62, 58, 55],
                            [65, 62, 58, 56], [66, 62, 58, 56], [66, 64, 58, 44, 38], [62, 59],
                            [64, 62, 59], [65, 62, 59], [66, 62, 59], [62, 59, 55], [62, 59, 56],
                            [62, 59, 57], [66, 64, 62, 59], [67, 64, 62, 59], [64, 62, 59, 56],
                            [64, 62, 59, 57], [67, 65, 62, 59], [65, 62, 59, 56], [69, 65, 62, 59],
                            [66, 62, 59, 56], [69, 66, 62, 59], [59, 55, 50, 45], [64, 62, 59, 56, 54],
                            [69, 66, 62, 59, 40], [64, 59, 55, 50, 45, 40], [69, 65, 62, 59, 55], [63],
                            [65, 63], [66, 63], [67, 63], [67, 65, 63], [68, 63], [68, 65, 63],
                            [68, 66, 63], [63, 57], [63, 57, 53], [66, 63, 57], [67, 63, 57],
                            [67, 63, 57, 53], [63, 58], [65, 63, 58], [66, 63, 58], [67, 63, 58],
                            [68, 63, 58], [67, 65, 63, 58], [63, 58, 56, 53], [70, 68, 66, 63], [63, 59],
                            [63, 59, 53], [66, 63, 59], [67, 63, 59], [63, 59, 56], [63, 59, 57],
                            [63, 59, 55, 53], [68, 65, 63, 59], [69, 65, 63, 59], [66, 63, 59, 56],
                            [66, 63, 59, 57], [67, 63, 59, 57], [67, 63, 59, 57, 41], [64], [66, 64],
                            [67, 64], [68, 64], [68, 66, 64], [69, 64], [69, 66, 64], [69, 67, 64],
                            [64, 58], [64, 58, 54], [64, 58, 55], [68, 64, 58], [68, 64, 58, 42], [64, 59],
                            [66, 64, 59], [64, 59, 55], [64, 59, 56], [64, 59, 57], [64, 59, 56, 54],
                            [64, 59, 57, 54], [69, 64, 59, 55], [65], [67, 65], [68, 65], [69, 65],
                            [69, 67, 65], [70, 65], [65, 58, 55], [70, 68, 65], [65, 59], [65, 59, 55],
                            [65, 59, 56], [59, 57, 53], [69, 65, 59, 55], [66], [68, 66], [69, 66],
                            [70, 66], [80, 70, 54], [59, 54, 47, 35], [66, 59, 56], [71, 69, 66], [67],
                            [69, 67], [70, 67], [59, 55], [71, 69, 67], [68], [70, 68], [59, 56], [69],
                            [71, 69], [70], [59]]

#===============================================================================

ALL_CHORDS_PAIRS_SORTED = [[[0], [0, 4, 7]], [[0, 2], [0, 4, 7]], [[0, 3], [0, 3, 7]],
                          [[0, 4], [0, 4, 7]], [[0, 2, 4], [0, 2, 4, 7]], [[0, 5], [0, 5, 9]],
                          [[0, 2, 5], [0, 2, 5, 9]], [[0, 3, 5], [0, 3, 5, 9]], [[0, 6], [0, 2, 6, 9]],
                          [[0, 2, 6], [0, 2, 6, 9]], [[0, 3, 6], [0, 3, 6, 8]],
                          [[0, 4, 6], [0, 4, 6, 9]], [[0, 2, 4, 6], [0, 2, 4, 6, 9]],
                          [[0, 7], [0, 4, 7]], [[0, 2, 7], [0, 2, 4, 7]], [[0, 3, 7], [0, 3, 7, 10]],
                          [[0, 4, 7], [0, 4, 7, 9]], [[0, 5, 7], [0, 5, 7, 9]],
                          [[0, 2, 4, 7], [0, 2, 4, 7, 9]], [[0, 2, 5, 7], [0, 2, 5, 7, 9]],
                          [[0, 3, 5, 7], [0, 3, 5, 7, 10]], [[0, 8], [0, 3, 8]],
                          [[0, 2, 8], [0, 2, 5, 8]], [[0, 3, 8], [0, 3, 5, 8]],
                          [[0, 4, 8], [2, 4, 8, 11]], [[0, 5, 8], [0, 3, 5, 8]],
                          [[0, 6, 8], [0, 3, 6, 8]], [[0, 2, 4, 8], [0, 2, 4, 6, 8]],
                          [[0, 2, 5, 8], [0, 2, 5, 8, 10]], [[0, 2, 6, 8], [0, 2, 6, 8, 10]],
                          [[0, 3, 5, 8], [0, 3, 5, 8, 10]], [[0, 3, 6, 8], [0, 3, 6, 8, 10]],
                          [[0, 4, 6, 8], [2, 4, 6, 8, 11]], [[0, 2, 4, 6, 8], [2, 4, 6, 8, 11]],
                          [[0, 9], [0, 4, 9]], [[0, 2, 9], [0, 2, 6, 9]], [[0, 3, 9], [0, 3, 5, 9]],
                          [[0, 4, 9], [0, 4, 7, 9]], [[0, 5, 9], [0, 2, 5, 9]],
                          [[0, 6, 9], [0, 2, 6, 9]], [[0, 7, 9], [0, 4, 7, 9]],
                          [[0, 2, 4, 9], [0, 2, 4, 7, 9]], [[0, 2, 5, 9], [0, 2, 5, 7, 9]],
                          [[0, 2, 6, 9], [0, 2, 4, 6, 9]], [[0, 2, 7, 9], [0, 2, 4, 7, 9]],
                          [[0, 3, 5, 9], [0, 3, 5, 7, 9]], [[0, 3, 6, 9], [0, 2, 4, 6, 9]],
                          [[0, 3, 7, 9], [0, 3, 5, 7, 9]], [[0, 4, 6, 9], [0, 2, 4, 6, 9]],
                          [[0, 4, 7, 9], [0, 2, 4, 7, 9]], [[0, 5, 7, 9], [0, 2, 5, 7, 9]],
                          [[0, 2, 4, 6, 9], [2, 4, 6, 9, 11]], [[0, 2, 4, 7, 9], [2, 4, 7, 9, 11]],
                          [[0, 2, 5, 7, 9], [2, 5, 7, 9, 11]], [[0, 3, 5, 7, 9], [2, 4, 6, 8, 11]],
                          [[0, 10], [2, 5, 10]], [[0, 2, 10], [0, 2, 5, 10]],
                          [[0, 3, 10], [0, 3, 7, 10]], [[0, 4, 10], [0, 4, 7, 10]],
                          [[0, 5, 10], [0, 2, 5, 10]], [[0, 6, 10], [0, 3, 6, 10]],
                          [[0, 7, 10], [0, 4, 7, 10]], [[0, 8, 10], [0, 3, 8, 10]],
                          [[0, 2, 4, 10], [0, 2, 4, 7, 10]], [[0, 2, 5, 10], [0, 2, 5, 7, 10]],
                          [[0, 2, 6, 10], [0, 2, 6, 8, 10]], [[0, 2, 7, 10], [0, 2, 5, 7, 10]],
                          [[0, 2, 8, 10], [0, 2, 5, 8, 10]], [[0, 3, 5, 10], [0, 3, 5, 7, 10]],
                          [[0, 3, 6, 10], [0, 3, 6, 8, 10]], [[0, 3, 7, 10], [0, 3, 5, 7, 10]],
                          [[0, 3, 8, 10], [0, 3, 5, 8, 10]], [[0, 4, 6, 10], [0, 2, 4, 6, 10]],
                          [[0, 4, 7, 10], [0, 2, 4, 7, 10]], [[0, 4, 8, 10], [0, 2, 4, 8, 10]],
                          [[0, 5, 7, 10], [0, 3, 5, 7, 10]], [[0, 5, 8, 10], [0, 3, 5, 8, 10]],
                          [[0, 6, 8, 10], [0, 3, 6, 8, 10]], [[0, 2, 4, 6, 10], [0, 2, 4, 8, 10]],
                          [[0, 2, 4, 7, 10], [1, 3, 6, 9, 11]], [[0, 2, 4, 8, 10], [1, 3, 7, 9, 11]],
                          [[0, 2, 5, 7, 10], [0, 3, 5, 7, 10]], [[0, 2, 5, 8, 10], [1, 4, 7, 9, 11]],
                          [[0, 2, 6, 8, 10], [2, 4, 6, 8, 10]], [[0, 3, 5, 7, 10], [0, 2, 5, 7, 10]],
                          [[0, 3, 5, 8, 10], [1, 3, 5, 8, 10]], [[0, 3, 6, 8, 10], [1, 3, 6, 8, 10]],
                          [[0, 4, 6, 8, 10], [0, 2, 4, 6, 9]],
                          [[0, 2, 4, 6, 8, 10], [1, 3, 5, 7, 9, 11]], [[1], [1, 8]], [[1, 3], [1, 5, 8]],
                          [[1, 4], [1, 4, 9]], [[1, 5], [1, 5, 8]], [[1, 3, 5], [1, 3, 5, 10]],
                          [[1, 6], [1, 6, 10]], [[1, 3, 6], [1, 3, 6, 10]], [[1, 4, 6], [1, 4, 6, 9]],
                          [[1, 7], [1, 4, 7]], [[1, 3, 7], [1, 3, 7, 10]], [[1, 4, 7], [1, 4, 7, 9]],
                          [[1, 5, 7], [1, 5, 7, 10]], [[1, 3, 5, 7], [1, 3, 5, 7, 10]],
                          [[1, 8], [1, 5, 8]], [[1, 3, 8], [1, 3, 5, 8]], [[1, 4, 8], [1, 4, 8, 11]],
                          [[1, 5, 8], [1, 5, 8, 10]], [[1, 6, 8], [1, 3, 6, 8]],
                          [[1, 3, 5, 8], [1, 3, 5, 8, 10]], [[1, 3, 6, 8], [1, 3, 6, 8, 10]],
                          [[1, 4, 6, 8], [1, 4, 6, 8, 11]], [[1, 9], [1, 4, 9]],
                          [[1, 3, 9], [1, 3, 6, 9]], [[1, 4, 9], [1, 4, 6, 9]],
                          [[1, 5, 9], [0, 3, 5, 9]], [[1, 6, 9], [1, 4, 6, 9]],
                          [[1, 7, 9], [1, 4, 7, 9]], [[1, 3, 5, 9], [0, 3, 5, 7, 9]],
                          [[1, 3, 6, 9], [1, 3, 6, 9, 11]], [[1, 3, 7, 9], [1, 3, 5, 7, 9]],
                          [[1, 4, 6, 9], [1, 4, 6, 9, 11]], [[1, 4, 7, 9], [1, 4, 7, 9, 11]],
                          [[1, 5, 7, 9], [1, 3, 7, 9, 11]], [[1, 3, 5, 7, 9], [2, 4, 6, 8, 11]],
                          [[1, 10], [1, 5, 10]], [[1, 3, 10], [1, 3, 7, 10]],
                          [[1, 4, 10], [1, 4, 6, 10]], [[1, 5, 10], [1, 5, 8, 10]],
                          [[1, 6, 10], [1, 4, 6, 10]], [[1, 7, 10], [1, 3, 7, 10]],
                          [[1, 8, 10], [1, 5, 8, 10]], [[1, 3, 5, 10], [1, 3, 5, 8, 10]],
                          [[1, 3, 6, 10], [1, 3, 6, 8, 10]], [[1, 3, 7, 10], [1, 3, 5, 7, 10]],
                          [[1, 3, 8, 10], [1, 3, 5, 8, 10]], [[1, 4, 6, 10], [1, 4, 6, 8, 10]],
                          [[1, 4, 7, 10], [0, 2, 4, 7, 10]], [[1, 4, 8, 10], [1, 4, 6, 8, 10]],
                          [[1, 5, 7, 10], [1, 3, 5, 7, 10]], [[1, 5, 8, 10], [1, 3, 5, 8, 10]],
                          [[1, 6, 8, 10], [1, 3, 6, 8, 10]], [[1, 3, 5, 7, 10], [2, 4, 6, 8, 11]],
                          [[1, 3, 5, 8, 10], [0, 3, 5, 8, 10]], [[1, 3, 6, 8, 10], [0, 3, 6, 8, 10]],
                          [[1, 4, 6, 8, 10], [0, 3, 5, 7, 9]], [[1, 11], [2, 6, 11]],
                          [[1, 3, 11], [1, 3, 6, 11]], [[1, 4, 11], [1, 4, 8, 11]],
                          [[1, 5, 11], [1, 5, 8, 11]], [[1, 6, 11], [1, 4, 6, 11]],
                          [[1, 7, 11], [1, 4, 7, 11]], [[1, 8, 11], [1, 4, 8, 11]],
                          [[1, 9, 11], [1, 4, 9, 11]], [[1, 3, 5, 11], [1, 3, 5, 8, 11]],
                          [[1, 3, 6, 11], [1, 3, 6, 8, 11]], [[1, 3, 7, 11], [1, 3, 7, 9, 11]],
                          [[1, 3, 8, 11], [1, 3, 6, 8, 11]], [[1, 3, 9, 11], [1, 3, 6, 9, 11]],
                          [[1, 4, 6, 11], [1, 4, 6, 9, 11]], [[1, 4, 7, 11], [1, 4, 7, 9, 11]],
                          [[1, 4, 8, 11], [1, 4, 6, 8, 11]], [[1, 4, 9, 11], [1, 4, 6, 9, 11]],
                          [[1, 5, 7, 11], [0, 4, 6, 8, 10]], [[1, 5, 8, 11], [1, 3, 5, 8, 11]],
                          [[1, 5, 9, 11], [1, 5, 7, 9, 11]], [[1, 6, 8, 11], [1, 3, 6, 8, 11]],
                          [[1, 6, 9, 11], [1, 4, 6, 9, 11]], [[1, 7, 9, 11], [1, 4, 7, 9, 11]],
                          [[1, 3, 5, 7, 11], [0, 2, 4, 6, 8]], [[1, 3, 5, 8, 11], [0, 2, 4, 7, 10]],
                          [[1, 3, 5, 9, 11], [1, 3, 7, 9, 11]], [[1, 3, 6, 8, 11], [1, 4, 6, 8, 11]],
                          [[1, 3, 6, 9, 11], [0, 2, 5, 8, 10]], [[1, 3, 7, 9, 11], [1, 3, 6, 9, 11]],
                          [[1, 4, 6, 8, 11], [1, 4, 6, 9, 11]], [[1, 4, 6, 9, 11], [2, 4, 6, 9, 11]],
                          [[1, 4, 7, 9, 11], [2, 4, 7, 9, 11]], [[1, 5, 7, 9, 11], [2, 4, 7, 9, 11]],
                          [[1, 3, 5, 7, 9, 11], [0, 2, 4, 6, 8, 10]], [[2], [2, 9]], [[2, 4], [2, 6, 9]],
                          [[2, 5], [2, 5, 9]], [[2, 6], [2, 6, 9]], [[2, 4, 6], [2, 4, 6, 9]],
                          [[2, 7], [2, 7, 11]], [[2, 4, 7], [2, 4, 7, 11]], [[2, 5, 7], [2, 5, 7, 11]],
                          [[2, 8], [4, 8, 11]], [[2, 4, 8], [2, 4, 8, 11]], [[2, 5, 8], [2, 5, 8, 10]],
                          [[2, 6, 8], [2, 6, 8, 11]], [[2, 4, 6, 8], [2, 4, 6, 8, 11]],
                          [[2, 9], [2, 6, 9]], [[2, 4, 9], [2, 4, 6, 9]], [[2, 5, 9], [0, 2, 5, 9]],
                          [[2, 6, 9], [2, 6, 9, 11]], [[2, 7, 9], [2, 7, 9, 11]],
                          [[2, 4, 6, 9], [2, 4, 6, 9, 11]], [[2, 4, 7, 9], [2, 4, 7, 9, 11]],
                          [[2, 5, 7, 9], [0, 2, 5, 7, 9]], [[2, 10], [2, 5, 10]],
                          [[2, 4, 10], [2, 4, 7, 10]], [[2, 5, 10], [2, 5, 7, 10]],
                          [[2, 6, 10], [1, 4, 6, 10]], [[2, 7, 10], [2, 5, 7, 10]],
                          [[2, 8, 10], [2, 5, 8, 10]], [[2, 4, 6, 10], [0, 2, 4, 6, 10]],
                          [[2, 4, 7, 10], [0, 2, 4, 7, 10]], [[2, 4, 8, 10], [2, 4, 7, 9, 11]],
                          [[2, 5, 7, 10], [0, 2, 5, 7, 10]], [[2, 5, 8, 10], [0, 2, 5, 8, 10]],
                          [[2, 6, 8, 10], [1, 3, 5, 7, 10]], [[2, 4, 6, 8, 10], [0, 2, 6, 8, 10]],
                          [[2, 11], [2, 7, 11]], [[2, 4, 11], [2, 4, 8, 11]],
                          [[2, 5, 11], [2, 5, 7, 11]], [[2, 6, 11], [2, 6, 9, 11]],
                          [[2, 7, 11], [2, 4, 7, 11]], [[2, 8, 11], [2, 4, 8, 11]],
                          [[2, 9, 11], [2, 6, 9, 11]], [[2, 4, 6, 11], [2, 4, 6, 9, 11]],
                          [[2, 4, 7, 11], [2, 4, 7, 9, 11]], [[2, 4, 8, 11], [2, 4, 6, 8, 11]],
                          [[2, 4, 9, 11], [2, 4, 7, 9, 11]], [[2, 5, 7, 11], [2, 5, 7, 9, 11]],
                          [[2, 5, 8, 11], [1, 3, 5, 8, 11]], [[2, 5, 9, 11], [2, 5, 7, 9, 11]],
                          [[2, 6, 8, 11], [2, 4, 6, 8, 11]], [[2, 6, 9, 11], [2, 4, 6, 9, 11]],
                          [[2, 7, 9, 11], [2, 4, 7, 9, 11]], [[2, 4, 6, 8, 11], [2, 4, 6, 9, 11]],
                          [[2, 4, 6, 9, 11], [2, 4, 7, 9, 11]], [[2, 4, 7, 9, 11], [0, 2, 4, 7, 9]],
                          [[2, 5, 7, 9, 11], [2, 4, 7, 9, 11]], [[3], [3, 10]], [[3, 5], [3, 7, 10]],
                          [[3, 6], [3, 6, 11]], [[3, 7], [3, 7, 10]], [[3, 5, 7], [3, 5, 7, 10]],
                          [[3, 8], [0, 3, 8]], [[3, 5, 8], [0, 3, 5, 8]], [[3, 6, 8], [0, 3, 6, 8]],
                          [[3, 9], [0, 3, 9]], [[3, 5, 9], [0, 3, 5, 9]], [[3, 6, 9], [3, 6, 9, 11]],
                          [[3, 7, 9], [0, 3, 7, 9]], [[3, 5, 7, 9], [0, 3, 5, 7, 9]],
                          [[3, 10], [3, 7, 10]], [[3, 5, 10], [3, 5, 7, 10]],
                          [[3, 6, 10], [1, 3, 6, 10]], [[3, 7, 10], [0, 3, 7, 10]],
                          [[3, 8, 10], [0, 3, 8, 10]], [[3, 5, 7, 10], [0, 3, 5, 7, 10]],
                          [[3, 5, 8, 10], [0, 3, 5, 8, 10]], [[3, 6, 8, 10], [1, 3, 6, 8, 10]],
                          [[3, 11], [3, 6, 11]], [[3, 5, 11], [3, 5, 8, 11]],
                          [[3, 6, 11], [3, 6, 9, 11]], [[3, 7, 11], [2, 5, 7, 11]],
                          [[3, 8, 11], [3, 6, 8, 11]], [[3, 9, 11], [3, 6, 9, 11]],
                          [[3, 5, 7, 11], [3, 5, 7, 9, 11]], [[3, 5, 8, 11], [1, 3, 5, 8, 11]],
                          [[3, 5, 9, 11], [3, 5, 7, 9, 11]], [[3, 6, 8, 11], [1, 3, 6, 8, 11]],
                          [[3, 6, 9, 11], [1, 3, 6, 9, 11]], [[3, 7, 9, 11], [2, 4, 7, 9, 11]],
                          [[3, 5, 7, 9, 11], [2, 5, 7, 9, 11]], [[4], [4, 11]], [[4, 6], [4, 7, 11]],
                          [[4, 7], [0, 4, 7]], [[4, 8], [4, 8, 11]], [[4, 6, 8], [4, 6, 8, 11]],
                          [[4, 9], [1, 4, 9]], [[4, 6, 9], [1, 4, 6, 9]], [[4, 7, 9], [1, 4, 7, 9]],
                          [[4, 10], [4, 7, 10]], [[4, 6, 10], [1, 4, 6, 10]],
                          [[4, 7, 10], [0, 4, 7, 10]], [[4, 8, 10], [1, 4, 8, 10]],
                          [[4, 6, 8, 10], [1, 4, 6, 8, 10]], [[4, 11], [4, 8, 11]],
                          [[4, 6, 11], [4, 6, 8, 11]], [[4, 7, 11], [2, 4, 7, 11]],
                          [[4, 8, 11], [2, 4, 8, 11]], [[4, 9, 11], [2, 4, 9, 11]],
                          [[4, 6, 8, 11], [1, 4, 6, 8, 11]], [[4, 6, 9, 11], [2, 4, 6, 9, 11]],
                          [[4, 7, 9, 11], [2, 4, 7, 9, 11]], [[5], [0, 5, 9]], [[5, 7], [0, 4, 7]],
                          [[5, 8], [0, 5, 8]], [[5, 9], [0, 5, 9]], [[5, 7, 9], [0, 4, 7, 9]],
                          [[5, 10], [2, 5, 10]], [[5, 7, 10], [2, 5, 7, 10]],
                          [[5, 8, 10], [2, 5, 8, 10]], [[5, 11], [0, 5, 9]], [[5, 7, 11], [2, 5, 7, 11]],
                          [[5, 8, 11], [1, 5, 8, 11]], [[5, 9, 11], [2, 5, 9, 11]],
                          [[5, 7, 9, 11], [2, 5, 7, 9, 11]], [[6], [1, 6]], [[6, 8], [1, 5, 8]],
                          [[6, 9], [2, 6, 9]], [[6, 10], [1, 6, 10]], [[6, 8, 10], [1, 5, 8, 10]],
                          [[6, 11], [3, 6, 11]], [[6, 8, 11], [3, 6, 8, 11]],
                          [[6, 9, 11], [3, 6, 9, 11]], [[7], [2, 7, 11]], [[7, 9], [2, 6, 9]],
                          [[7, 10], [2, 7, 10]], [[7, 11], [2, 7, 11]], [[7, 9, 11], [2, 7, 9, 11]],
                          [[8], [3, 8]], [[8, 10], [3, 7, 10]], [[8, 11], [4, 8, 11]], [[9], [4, 9]],
                          [[9, 11], [4, 8, 11]], [[10], [2, 5, 10]], [[11], [6, 11]]]

#===============================================================================

ALL_CHORDS_PAIRS_FILTERED = [[[0], [0, 4, 7]], [[0, 3], [0, 3, 7]], [[0, 3, 5], [0, 3, 5, 9]],
                            [[0, 3, 5, 8], [0, 3, 7, 10]], [[0, 3, 5, 9], [0, 3, 7, 10]],
                            [[0, 3, 5, 10], [0, 3, 5, 9]], [[0, 3, 7], [0, 3, 7, 10]],
                            [[0, 3, 7, 10], [0, 3, 5, 9]], [[0, 3, 8], [0, 3, 5, 8]],
                            [[0, 3, 9], [0, 3, 5, 9]], [[0, 3, 10], [0, 3, 7, 10]], [[0, 4], [0, 4, 7]],
                            [[0, 4, 6], [0, 4, 6, 9]], [[0, 4, 6, 9], [1, 4, 6, 9]],
                            [[0, 4, 6, 10], [0, 4, 7, 10]], [[0, 4, 7], [0, 4, 7, 10]],
                            [[0, 4, 7, 10], [1, 4, 7, 10]], [[0, 4, 8], [0, 4, 7, 10]],
                            [[0, 4, 9], [0, 4, 6, 9]], [[0, 4, 10], [0, 4, 7, 10]], [[0, 5], [0, 5, 9]],
                            [[0, 5, 8], [0, 3, 5, 8]], [[0, 5, 9], [0, 3, 5, 9]],
                            [[0, 5, 10], [0, 3, 5, 10]], [[0, 6], [0, 6, 9]], [[0, 6, 9], [0, 4, 6, 9]],
                            [[0, 6, 10], [0, 4, 7, 10]], [[0, 7], [0, 4, 7]], [[0, 7, 10], [0, 4, 7, 10]],
                            [[0, 8], [0, 3, 8]], [[0, 9], [0, 4, 9]], [[0, 10], [2, 5, 10]], [[1], [1, 8]],
                            [[1, 4], [1, 4, 9]], [[1, 4, 6], [1, 4, 6, 9]], [[1, 4, 6, 9], [1, 4, 8, 11]],
                            [[1, 4, 6, 10], [0, 3, 5, 9]], [[1, 4, 6, 11], [1, 4, 6, 9]],
                            [[1, 4, 7], [1, 4, 7, 10]], [[1, 4, 7, 10], [0, 4, 7, 10]],
                            [[1, 4, 7, 11], [1, 4, 6, 10]], [[1, 4, 8], [1, 4, 8, 11]],
                            [[1, 4, 8, 11], [1, 4, 6, 9]], [[1, 4, 9], [1, 4, 6, 9]],
                            [[1, 4, 10], [1, 4, 6, 10]], [[1, 4, 11], [1, 4, 8, 11]], [[1, 5], [1, 5, 8]],
                            [[1, 5, 8], [1, 5, 8, 11]], [[1, 5, 8, 11], [2, 5, 8, 11]],
                            [[1, 5, 9], [0, 3, 5, 9]], [[1, 5, 10], [0, 4, 7, 10]],
                            [[1, 5, 11], [1, 5, 8, 11]], [[1, 6], [1, 6, 10]], [[1, 6, 9], [1, 4, 6, 9]],
                            [[1, 6, 10], [1, 4, 6, 10]], [[1, 6, 11], [1, 4, 6, 11]], [[1, 7], [1, 4, 7]],
                            [[1, 7, 10], [1, 4, 7, 10]], [[1, 7, 11], [1, 4, 7, 11]], [[1, 8], [1, 5, 8]],
                            [[1, 8, 11], [1, 4, 8, 11]], [[1, 9], [1, 4, 9]], [[1, 10], [1, 5, 10]],
                            [[1, 11], [2, 6, 11]], [[2], [2, 9]], [[2, 5], [2, 5, 9]],
                            [[2, 5, 8], [2, 5, 8, 11]], [[2, 5, 8, 11], [1, 4, 7, 10]],
                            [[2, 5, 9], [0, 3, 5, 9]], [[2, 5, 10], [0, 3, 5, 9]],
                            [[2, 5, 11], [2, 5, 8, 11]], [[2, 6], [2, 6, 9]], [[2, 6, 9], [1, 4, 6, 9]],
                            [[2, 6, 10], [1, 4, 6, 10]], [[2, 6, 11], [1, 4, 6, 10]], [[2, 7], [2, 7, 11]],
                            [[2, 7, 10], [0, 4, 7, 10]], [[2, 7, 11], [1, 4, 6, 9]], [[2, 8], [4, 8, 11]],
                            [[2, 8, 11], [2, 5, 8, 11]], [[2, 9], [2, 6, 9]], [[2, 10], [2, 5, 10]],
                            [[2, 11], [2, 7, 11]], [[3], [3, 10]], [[3, 5], [3, 7, 10]],
                            [[3, 5, 8], [0, 3, 5, 8]], [[3, 5, 8, 11], [2, 5, 8, 11]],
                            [[3, 5, 9], [0, 3, 5, 9]], [[3, 5, 10], [0, 3, 5, 10]],
                            [[3, 5, 11], [3, 5, 8, 11]], [[3, 7], [3, 7, 10]], [[3, 7, 10], [0, 3, 7, 10]],
                            [[3, 7, 11], [0, 3, 7, 10]], [[3, 8], [0, 3, 8]], [[3, 8, 11], [3, 5, 8, 11]],
                            [[3, 9], [0, 3, 9]], [[3, 10], [3, 7, 10]], [[3, 11], [3, 8, 11]],
                            [[4], [4, 11]], [[4, 6], [4, 7, 11]], [[4, 6, 9], [1, 4, 6, 9]],
                            [[4, 6, 10], [1, 4, 6, 10]], [[4, 6, 11], [1, 4, 6, 11]], [[4, 7], [0, 4, 7]],
                            [[4, 7, 10], [0, 4, 7, 10]], [[4, 7, 11], [1, 4, 7, 11]], [[4, 8], [4, 8, 11]],
                            [[4, 8, 11], [1, 4, 8, 11]], [[4, 9], [1, 4, 9]], [[4, 10], [4, 7, 10]],
                            [[4, 11], [4, 8, 11]], [[5], [0, 5, 9]], [[5, 8], [0, 5, 8]],
                            [[5, 8, 11], [1, 5, 8, 11]], [[5, 9], [0, 5, 9]], [[5, 10], [2, 5, 10]],
                            [[5, 11], [0, 5, 9]], [[6], [1, 6]], [[6, 9], [2, 6, 9]],
                            [[6, 10], [1, 6, 10]], [[6, 11], [2, 6, 11]], [[7], [2, 7, 11]],
                            [[7, 10], [2, 7, 10]], [[7, 11], [2, 7, 11]], [[8], [3, 8]],
                            [[8, 11], [4, 8, 11]], [[9], [4, 9]], [[10], [2, 5, 10]], [[11], [6, 11]]]

#===============================================================================

ALL_CHORDS_TRIPLETS_SORTED = [[[0], [0, 4, 7], [0]], [[0, 2], [0, 4, 7], [0]], [[0, 3], [0, 3, 7], [0]],
                              [[0, 4], [0, 4, 7], [0, 4]], [[0, 2, 4], [0, 2, 4, 7], [0]],
                              [[0, 5], [0, 5, 9], [0, 5]], [[0, 2, 5], [0, 2, 5, 9], [0, 2, 5]],
                              [[0, 3, 5], [0, 3, 5, 9], [0, 3, 5]], [[0, 6], [0, 2, 6, 9], [2]],
                              [[0, 2, 6], [0, 2, 6, 9], [0, 2, 6]], [[0, 3, 6], [0, 3, 6, 8], [0, 3, 6]],
                              [[0, 4, 6], [0, 4, 6, 9], [0, 4, 6]],
                              [[0, 2, 4, 6], [0, 2, 4, 6, 9], [0, 2, 4, 6]], [[0, 7], [0, 4, 7], [0, 7]],
                              [[0, 2, 7], [0, 2, 4, 7], [0, 2, 7]], [[0, 3, 7], [0, 3, 7, 10], [0, 3, 7]],
                              [[0, 4, 7], [0, 4, 7, 9], [0, 4, 7]], [[0, 5, 7], [0, 5, 7, 9], [0, 5, 7]],
                              [[0, 2, 4, 7], [0, 2, 4, 7, 9], [0, 2, 4, 7]],
                              [[0, 2, 5, 7], [0, 2, 5, 7, 9], [0, 2, 5, 7]],
                              [[0, 3, 5, 7], [0, 3, 5, 7, 10], [0, 3, 5, 7]], [[0, 8], [0, 3, 8], [8]],
                              [[0, 2, 8], [0, 2, 5, 8], [0, 2, 8]], [[0, 3, 8], [0, 3, 5, 8], [0, 3, 8]],
                              [[0, 4, 8], [2, 4, 8, 11], [0, 4, 9]], [[0, 5, 8], [0, 3, 5, 8], [0, 5, 8]],
                              [[0, 6, 8], [0, 3, 6, 8], [0, 6, 8]],
                              [[0, 2, 4, 8], [0, 2, 4, 6, 8], [0, 2, 4, 8]],
                              [[0, 2, 5, 8], [0, 2, 5, 8, 10], [0, 2, 5, 8]],
                              [[0, 2, 6, 8], [0, 2, 6, 8, 10], [0, 2, 6, 8]],
                              [[0, 3, 5, 8], [0, 3, 5, 8, 10], [0, 3, 5, 8]],
                              [[0, 3, 6, 8], [0, 3, 6, 8, 10], [0, 3, 6, 8]],
                              [[0, 4, 6, 8], [2, 4, 6, 8, 11], [2, 6, 8, 11]],
                              [[0, 2, 4, 6, 8], [2, 4, 6, 8, 11], [2, 6, 8, 11]], [[0, 9], [0, 4, 9], [9]],
                              [[0, 2, 9], [0, 2, 6, 9], [0, 2, 9]], [[0, 3, 9], [0, 3, 5, 9], [0, 3, 9]],
                              [[0, 4, 9], [0, 4, 7, 9], [0, 4, 9]], [[0, 5, 9], [0, 2, 5, 9], [0, 5, 9]],
                              [[0, 6, 9], [0, 2, 6, 9], [0, 6, 9]], [[0, 7, 9], [0, 4, 7, 9], [0, 7, 9]],
                              [[0, 2, 4, 9], [0, 2, 4, 7, 9], [0, 2, 4, 9]],
                              [[0, 2, 5, 9], [0, 2, 5, 7, 9], [0, 2, 5, 9]],
                              [[0, 2, 6, 9], [0, 2, 4, 6, 9], [0, 2, 6, 9]],
                              [[0, 2, 7, 9], [0, 2, 4, 7, 9], [0, 2, 7, 9]],
                              [[0, 3, 5, 9], [0, 3, 5, 7, 9], [0, 3, 5, 9]],
                              [[0, 3, 6, 9], [0, 2, 4, 6, 9], [4, 6, 9]],
                              [[0, 3, 7, 9], [0, 3, 5, 7, 9], [0, 3, 7, 9]],
                              [[0, 4, 6, 9], [0, 2, 4, 6, 9], [0, 4, 6, 9]],
                              [[0, 4, 7, 9], [0, 2, 4, 7, 9], [0, 4, 7, 9]],
                              [[0, 5, 7, 9], [0, 2, 5, 7, 9], [0, 5, 7, 9]],
                              [[0, 2, 4, 6, 9], [2, 4, 6, 9, 11], [0, 2, 4, 6, 9]],
                              [[0, 2, 4, 7, 9], [2, 4, 7, 9, 11], [0, 2, 4, 7, 9]],
                              [[0, 2, 5, 7, 9], [2, 5, 7, 9, 11], [7]],
                              [[0, 3, 5, 7, 9], [2, 4, 6, 8, 11], [1, 4, 6, 8, 10]],
                              [[0, 10], [2, 5, 10], [10]], [[0, 2, 10], [0, 2, 5, 10], [10]],
                              [[0, 3, 10], [0, 3, 7, 10], [0, 3, 10]],
                              [[0, 4, 10], [0, 4, 7, 10], [0, 4, 10]],
                              [[0, 5, 10], [0, 2, 5, 10], [0, 5, 10]],
                              [[0, 6, 10], [0, 3, 6, 10], [0, 6, 10]],
                              [[0, 7, 10], [0, 4, 7, 10], [0, 7, 10]], [[0, 8, 10], [0, 3, 8, 10], [8]],
                              [[0, 2, 4, 10], [0, 2, 4, 7, 10], [0, 4, 10]],
                              [[0, 2, 5, 10], [0, 2, 5, 7, 10], [0, 2, 5, 10]],
                              [[0, 2, 6, 10], [0, 2, 6, 8, 10], [8]],
                              [[0, 2, 7, 10], [0, 2, 5, 7, 10], [2, 7, 10]],
                              [[0, 2, 8, 10], [0, 2, 5, 8, 10], [8, 10]],
                              [[0, 3, 5, 10], [0, 3, 5, 7, 10], [0, 3, 5, 10]],
                              [[0, 3, 6, 10], [0, 3, 6, 8, 10], [0, 3, 6, 10]],
                              [[0, 3, 7, 10], [0, 3, 5, 7, 10], [0, 3, 7, 10]],
                              [[0, 3, 8, 10], [0, 3, 5, 8, 10], [0, 3, 8, 10]],
                              [[0, 4, 6, 10], [0, 2, 4, 6, 10], [2]],
                              [[0, 4, 7, 10], [0, 2, 4, 7, 10], [0, 4, 7, 10]],
                              [[0, 4, 8, 10], [0, 2, 4, 8, 10], [0, 4, 8, 10]],
                              [[0, 5, 7, 10], [0, 3, 5, 7, 10], [0, 5, 7, 10]],
                              [[0, 5, 8, 10], [0, 3, 5, 8, 10], [10]],
                              [[0, 6, 8, 10], [0, 3, 6, 8, 10], [6]],
                              [[0, 2, 4, 6, 10], [0, 2, 4, 8, 10], [0, 2, 6, 8, 10]],
                              [[0, 2, 4, 7, 10], [1, 3, 6, 9, 11], [0, 2, 5, 8, 10]],
                              [[0, 2, 4, 8, 10], [1, 3, 7, 9, 11], [0, 2, 6, 8, 10]],
                              [[0, 2, 5, 7, 10], [0, 3, 5, 7, 10], [5, 10]],
                              [[0, 2, 5, 8, 10], [1, 4, 7, 9, 11], [8]],
                              [[0, 2, 6, 8, 10], [2, 4, 6, 8, 10], [0, 2, 6, 8, 10]],
                              [[0, 3, 5, 7, 10], [0, 2, 5, 7, 10], [9]],
                              [[0, 3, 5, 8, 10], [1, 3, 5, 8, 10], [0, 3, 5, 8, 10]],
                              [[0, 3, 6, 8, 10], [1, 3, 6, 8, 10], [0, 3, 6, 8, 10]],
                              [[0, 4, 6, 8, 10], [0, 2, 4, 6, 9], [1, 3, 5, 8, 10]],
                              [[0, 2, 4, 6, 8, 10], [1, 3, 5, 7, 9, 11], [0, 2, 4, 6, 8, 10]],
                              [[1], [1, 8], [1]], [[1, 3], [1, 5, 8], [1]], [[1, 4], [1, 4, 9], [9]],
                              [[1, 5], [1, 5, 8], [1, 5]], [[1, 3, 5], [1, 3, 5, 10], [1, 3, 5]],
                              [[1, 6], [1, 6, 10], [1, 6]], [[1, 3, 6], [1, 3, 6, 10], [1, 3, 6]],
                              [[1, 4, 6], [1, 4, 6, 9], [1, 4, 6]], [[1, 7], [1, 4, 7], [1, 7]],
                              [[1, 3, 7], [1, 3, 7, 10], [1, 3, 7]], [[1, 4, 7], [1, 4, 7, 9], [1, 4, 7]],
                              [[1, 5, 7], [1, 5, 7, 10], [1, 5, 7]], [[1, 3, 5, 7], [1, 3, 5, 7, 10], [7]],
                              [[1, 8], [1, 5, 8], [1, 8]], [[1, 3, 8], [1, 3, 5, 8], [1, 3, 8]],
                              [[1, 4, 8], [1, 4, 8, 11], [1, 4, 8]], [[1, 5, 8], [1, 5, 8, 10], [1, 5, 8]],
                              [[1, 6, 8], [1, 3, 6, 8], [1, 6, 8]],
                              [[1, 3, 5, 8], [1, 3, 5, 8, 10], [1, 3, 5, 8]],
                              [[1, 3, 6, 8], [1, 3, 6, 8, 10], [1, 3, 6, 8]],
                              [[1, 4, 6, 8], [1, 4, 6, 8, 11], [1, 4, 6, 8]], [[1, 9], [1, 4, 9], [9]],
                              [[1, 3, 9], [1, 3, 6, 9], [1, 3, 9]], [[1, 4, 9], [1, 4, 6, 9], [1, 4, 9]],
                              [[1, 5, 9], [0, 3, 5, 9], [0, 5, 9]], [[1, 6, 9], [1, 4, 6, 9], [1, 6, 9]],
                              [[1, 7, 9], [1, 4, 7, 9], [1, 7, 9]],
                              [[1, 3, 5, 9], [0, 3, 5, 7, 9], [1, 5, 9]],
                              [[1, 3, 6, 9], [1, 3, 6, 9, 11], [1, 3, 6, 9]],
                              [[1, 3, 7, 9], [1, 3, 5, 7, 9], [1, 7]],
                              [[1, 4, 6, 9], [1, 4, 6, 9, 11], [1, 4, 6, 9]],
                              [[1, 4, 7, 9], [1, 4, 7, 9, 11], [1, 4, 7, 9]],
                              [[1, 5, 7, 9], [1, 3, 7, 9, 11], [1, 5, 7, 9]],
                              [[1, 3, 5, 7, 9], [2, 4, 6, 8, 11], [9]], [[1, 10], [1, 5, 10], [10]],
                              [[1, 3, 10], [1, 3, 7, 10], [1, 3, 10]],
                              [[1, 4, 10], [1, 4, 6, 10], [1, 4, 10]],
                              [[1, 5, 10], [1, 5, 8, 10], [1, 5, 10]],
                              [[1, 6, 10], [1, 4, 6, 10], [1, 6, 10]],
                              [[1, 7, 10], [1, 3, 7, 10], [1, 7, 10]], [[1, 8, 10], [1, 5, 8, 10], [10]],
                              [[1, 3, 5, 10], [1, 3, 5, 8, 10], [1, 3, 5, 10]],
                              [[1, 3, 6, 10], [1, 3, 6, 8, 10], [1, 3, 6, 10]],
                              [[1, 3, 7, 10], [1, 3, 5, 7, 10], [1, 3, 7, 10]],
                              [[1, 3, 8, 10], [1, 3, 5, 8, 10], [1, 3, 8, 10]],
                              [[1, 4, 6, 10], [1, 4, 6, 8, 10], [1, 4, 6, 10]],
                              [[1, 4, 7, 10], [0, 2, 4, 7, 10], [0, 4, 7, 10]],
                              [[1, 4, 8, 10], [1, 4, 6, 8, 10], [1, 4, 8, 10]],
                              [[1, 5, 7, 10], [1, 3, 5, 7, 10], [1, 5, 7, 10]],
                              [[1, 5, 8, 10], [1, 3, 5, 8, 10], [1, 5, 8, 10]],
                              [[1, 6, 8, 10], [1, 3, 6, 8, 10], [1, 6, 8, 10]],
                              [[1, 3, 5, 7, 10], [2, 4, 6, 8, 11], [0, 3, 5, 7, 9]],
                              [[1, 3, 5, 8, 10], [0, 3, 5, 8, 10], [6, 8, 10]],
                              [[1, 3, 6, 8, 10], [0, 3, 6, 8, 10], [8]],
                              [[1, 4, 6, 8, 10], [0, 3, 5, 7, 9], [2, 4, 6, 8, 11]],
                              [[1, 11], [2, 6, 11], [11]], [[1, 3, 11], [1, 3, 6, 11], [11]],
                              [[1, 4, 11], [1, 4, 8, 11], [1]], [[1, 5, 11], [1, 5, 8, 11], [1, 5, 11]],
                              [[1, 6, 11], [1, 4, 6, 11], [1, 6, 11]],
                              [[1, 7, 11], [1, 4, 7, 11], [1, 7, 11]],
                              [[1, 8, 11], [1, 4, 8, 11], [1, 8, 11]], [[1, 9, 11], [1, 4, 9, 11], [9]],
                              [[1, 3, 5, 11], [1, 3, 5, 8, 11], [1, 3, 5, 11]],
                              [[1, 3, 6, 11], [1, 3, 6, 8, 11], [1, 3, 6, 11]],
                              [[1, 3, 7, 11], [1, 3, 7, 9, 11], [0]],
                              [[1, 3, 8, 11], [1, 3, 6, 8, 11], [1, 3, 8, 11]],
                              [[1, 3, 9, 11], [1, 3, 6, 9, 11], [1, 3, 9, 11]],
                              [[1, 4, 6, 11], [1, 4, 6, 9, 11], [1, 4, 6, 11]],
                              [[1, 4, 7, 11], [1, 4, 7, 9, 11], [1, 4, 7, 11]],
                              [[1, 4, 8, 11], [1, 4, 6, 8, 11], [1, 4, 8, 11]],
                              [[1, 4, 9, 11], [1, 4, 6, 9, 11], [1, 4, 9, 11]],
                              [[1, 5, 7, 11], [0, 4, 6, 8, 10], [5, 7, 9, 11]],
                              [[1, 5, 8, 11], [1, 3, 5, 8, 11], [1, 5, 8, 11]],
                              [[1, 5, 9, 11], [1, 5, 7, 9, 11], [9]],
                              [[1, 6, 8, 11], [1, 3, 6, 8, 11], [1, 6, 8, 11]],
                              [[1, 6, 9, 11], [1, 4, 6, 9, 11], [1, 6, 9, 11]],
                              [[1, 7, 9, 11], [1, 4, 7, 9, 11], [1, 7, 9, 11]],
                              [[1, 3, 5, 7, 11], [0, 2, 4, 6, 8], [7, 9]],
                              [[1, 3, 5, 8, 11], [0, 2, 4, 7, 10], [1, 3, 6, 9, 11]],
                              [[1, 3, 5, 9, 11], [1, 3, 7, 9, 11], [0, 2, 6, 8, 10]],
                              [[1, 3, 6, 8, 11], [1, 4, 6, 8, 11], [6, 8, 11]],
                              [[1, 3, 6, 9, 11], [0, 2, 5, 8, 10], [1, 4, 7, 9, 11]],
                              [[1, 3, 7, 9, 11], [1, 3, 6, 9, 11], [11]],
                              [[1, 4, 6, 8, 11], [1, 4, 6, 9, 11], [9, 11]],
                              [[1, 4, 6, 9, 11], [2, 4, 6, 9, 11], [1, 4, 6, 9, 11]],
                              [[1, 4, 7, 9, 11], [2, 4, 7, 9, 11], [7, 9, 11]],
                              [[1, 5, 7, 9, 11], [2, 4, 7, 9, 11], [5, 7, 9]],
                              [[1, 3, 5, 7, 9, 11], [0, 2, 4, 6, 8, 10], [1, 3, 5, 7, 9, 11]],
                              [[2], [2, 9], [2]], [[2, 4], [2, 6, 9], [2]], [[2, 5], [2, 5, 9], [2]],
                              [[2, 6], [2, 6, 9], [2]], [[2, 4, 6], [2, 4, 6, 9], [2, 4, 6]],
                              [[2, 7], [2, 7, 11], [2, 7]], [[2, 4, 7], [2, 4, 7, 11], [2, 4, 7]],
                              [[2, 5, 7], [2, 5, 7, 11], [2, 5, 7]], [[2, 8], [4, 8, 11], [4]],
                              [[2, 4, 8], [2, 4, 8, 11], [2, 4, 8]], [[2, 5, 8], [2, 5, 8, 10], [2, 5, 8]],
                              [[2, 6, 8], [2, 6, 8, 11], [2, 6, 8]],
                              [[2, 4, 6, 8], [2, 4, 6, 8, 11], [2, 4, 6, 8]], [[2, 9], [2, 6, 9], [2, 9]],
                              [[2, 4, 9], [2, 4, 6, 9], [2, 4, 9]], [[2, 5, 9], [0, 2, 5, 9], [2, 5, 9]],
                              [[2, 6, 9], [2, 6, 9, 11], [2, 6, 9]], [[2, 7, 9], [2, 7, 9, 11], [2, 7, 9]],
                              [[2, 4, 6, 9], [2, 4, 6, 9, 11], [2, 4, 6, 9]],
                              [[2, 4, 7, 9], [2, 4, 7, 9, 11], [2, 4, 7, 9]],
                              [[2, 5, 7, 9], [0, 2, 5, 7, 9], [2, 5, 7, 9]], [[2, 10], [2, 5, 10], [10]],
                              [[2, 4, 10], [2, 4, 7, 10], [2, 4, 10]],
                              [[2, 5, 10], [2, 5, 7, 10], [2, 5, 10]],
                              [[2, 6, 10], [1, 4, 6, 10], [1, 6, 10]],
                              [[2, 7, 10], [2, 5, 7, 10], [2, 7, 10]],
                              [[2, 8, 10], [2, 5, 8, 10], [2, 8, 10]],
                              [[2, 4, 6, 10], [0, 2, 4, 6, 10], [2, 4, 6, 10]],
                              [[2, 4, 7, 10], [0, 2, 4, 7, 10], [2, 4, 7, 10]],
                              [[2, 4, 8, 10], [2, 4, 7, 9, 11], [2, 4, 7, 11]],
                              [[2, 5, 7, 10], [0, 2, 5, 7, 10], [2, 5, 7, 10]],
                              [[2, 5, 8, 10], [0, 2, 5, 8, 10], [2, 5, 8, 10]],
                              [[2, 6, 8, 10], [1, 3, 5, 7, 10], [1, 7]],
                              [[2, 4, 6, 8, 10], [0, 2, 6, 8, 10], [2, 4, 6, 8, 10]],
                              [[2, 11], [2, 7, 11], [7]], [[2, 4, 11], [2, 4, 8, 11], [2, 4, 11]],
                              [[2, 5, 11], [2, 5, 7, 11], [2, 5, 11]],
                              [[2, 6, 11], [2, 6, 9, 11], [2, 6, 11]],
                              [[2, 7, 11], [2, 4, 7, 11], [2, 7, 11]],
                              [[2, 8, 11], [2, 4, 8, 11], [2, 8, 11]],
                              [[2, 9, 11], [2, 6, 9, 11], [2, 9, 11]],
                              [[2, 4, 6, 11], [2, 4, 6, 9, 11], [2, 4, 6, 11]],
                              [[2, 4, 7, 11], [2, 4, 7, 9, 11], [2, 4, 7, 11]],
                              [[2, 4, 8, 11], [2, 4, 6, 8, 11], [2, 4, 8, 11]],
                              [[2, 4, 9, 11], [2, 4, 7, 9, 11], [2, 4, 9, 11]],
                              [[2, 5, 7, 11], [2, 5, 7, 9, 11], [2, 5, 7, 11]],
                              [[2, 5, 8, 11], [1, 3, 5, 8, 11], [1, 5, 8, 11]],
                              [[2, 5, 9, 11], [2, 5, 7, 9, 11], [2, 5, 9, 11]],
                              [[2, 6, 8, 11], [2, 4, 6, 8, 11], [2, 6, 8, 11]],
                              [[2, 6, 9, 11], [2, 4, 6, 9, 11], [2, 6, 9, 11]],
                              [[2, 7, 9, 11], [2, 4, 7, 9, 11], [2, 7, 9, 11]],
                              [[2, 4, 6, 8, 11], [2, 4, 6, 9, 11], [2, 4, 6, 8, 11]],
                              [[2, 4, 6, 9, 11], [2, 4, 7, 9, 11], [2, 7, 9]],
                              [[2, 4, 7, 9, 11], [0, 2, 4, 7, 9], [11]],
                              [[2, 5, 7, 9, 11], [2, 4, 7, 9, 11], [2, 7, 9, 11]], [[3], [3, 10], [3]],
                              [[3, 5], [3, 7, 10], [3]], [[3, 6], [3, 6, 11], [11]],
                              [[3, 7], [3, 7, 10], [3]], [[3, 5, 7], [3, 5, 7, 10], [3, 5, 7]],
                              [[3, 8], [0, 3, 8], [3, 8]], [[3, 5, 8], [0, 3, 5, 8], [8]],
                              [[3, 6, 8], [0, 3, 6, 8], [3, 6, 8]], [[3, 9], [0, 3, 9], [3, 9]],
                              [[3, 5, 9], [0, 3, 5, 9], [3, 5, 9]], [[3, 6, 9], [3, 6, 9, 11], [3, 6, 9]],
                              [[3, 7, 9], [0, 3, 7, 9], [3, 7, 9]],
                              [[3, 5, 7, 9], [0, 3, 5, 7, 9], [0, 3, 5, 9]], [[3, 10], [3, 7, 10], [3, 10]],
                              [[3, 5, 10], [3, 5, 7, 10], [3, 5, 10]],
                              [[3, 6, 10], [1, 3, 6, 10], [3, 6, 10]],
                              [[3, 7, 10], [0, 3, 7, 10], [3, 7, 10]],
                              [[3, 8, 10], [0, 3, 8, 10], [3, 8, 10]],
                              [[3, 5, 7, 10], [0, 3, 5, 7, 10], [3, 5, 7, 10]],
                              [[3, 5, 8, 10], [0, 3, 5, 8, 10], [3, 5, 8, 10]],
                              [[3, 6, 8, 10], [1, 3, 6, 8, 10], [3, 6, 8, 10]], [[3, 11], [3, 6, 11], [11]],
                              [[3, 5, 11], [3, 5, 8, 11], [3, 5, 11]],
                              [[3, 6, 11], [3, 6, 9, 11], [3, 6, 11]],
                              [[3, 7, 11], [2, 5, 7, 11], [2, 7, 11]],
                              [[3, 8, 11], [3, 6, 8, 11], [3, 8, 11]],
                              [[3, 9, 11], [3, 6, 9, 11], [3, 9, 11]],
                              [[3, 5, 7, 11], [3, 5, 7, 9, 11], [3, 5, 7, 11]],
                              [[3, 5, 8, 11], [1, 3, 5, 8, 11], [3, 5, 8, 11]],
                              [[3, 5, 9, 11], [3, 5, 7, 9, 11], [5, 7, 9, 11]],
                              [[3, 6, 8, 11], [1, 3, 6, 8, 11], [3, 6, 8, 11]],
                              [[3, 6, 9, 11], [1, 3, 6, 9, 11], [3, 6, 9, 11]],
                              [[3, 7, 9, 11], [2, 4, 7, 9, 11], [7, 9, 11]],
                              [[3, 5, 7, 9, 11], [2, 5, 7, 9, 11], [2, 5, 7, 11]], [[4], [4, 11], [4]],
                              [[4, 6], [4, 7, 11], [4]], [[4, 7], [0, 4, 7], [0]], [[4, 8], [4, 8, 11], [4]],
                              [[4, 6, 8], [4, 6, 8, 11], [4]], [[4, 9], [1, 4, 9], [4, 9]],
                              [[4, 6, 9], [1, 4, 6, 9], [4, 6, 9]], [[4, 7, 9], [1, 4, 7, 9], [4, 7, 9]],
                              [[4, 10], [4, 7, 10], [4, 10]], [[4, 6, 10], [1, 4, 6, 10], [4, 6, 10]],
                              [[4, 7, 10], [0, 4, 7, 10], [4, 7, 10]], [[4, 8, 10], [1, 4, 8, 10], [1]],
                              [[4, 6, 8, 10], [1, 4, 6, 8, 10], [6]], [[4, 11], [4, 8, 11], [4, 11]],
                              [[4, 6, 11], [4, 6, 8, 11], [4, 6, 11]],
                              [[4, 7, 11], [2, 4, 7, 11], [4, 7, 11]],
                              [[4, 8, 11], [2, 4, 8, 11], [4, 8, 11]],
                              [[4, 9, 11], [2, 4, 9, 11], [4, 9, 11]],
                              [[4, 6, 8, 11], [1, 4, 6, 8, 11], [4, 6, 8, 11]],
                              [[4, 6, 9, 11], [2, 4, 6, 9, 11], [4, 6, 9, 11]],
                              [[4, 7, 9, 11], [2, 4, 7, 9, 11], [4, 7, 9, 11]], [[5], [0, 5, 9], [5]],
                              [[5, 7], [0, 4, 7], [0]], [[5, 8], [0, 5, 8], [5]], [[5, 9], [0, 5, 9], [5]],
                              [[5, 7, 9], [0, 4, 7, 9], [5]], [[5, 10], [2, 5, 10], [5, 10]],
                              [[5, 7, 10], [2, 5, 7, 10], [7]], [[5, 8, 10], [2, 5, 8, 10], [5, 8, 10]],
                              [[5, 11], [0, 5, 9], [5]], [[5, 7, 11], [2, 5, 7, 11], [5, 7, 11]],
                              [[5, 8, 11], [1, 5, 8, 11], [5, 8, 11]],
                              [[5, 9, 11], [2, 5, 9, 11], [5, 9, 11]],
                              [[5, 7, 9, 11], [2, 5, 7, 9, 11], [5, 7, 9]], [[6], [1, 6], [6]],
                              [[6, 8], [1, 5, 8], [8]], [[6, 9], [2, 6, 9], [2]], [[6, 10], [1, 6, 10], [6]],
                              [[6, 8, 10], [1, 5, 8, 10], [6, 8, 10]], [[6, 11], [3, 6, 11], [6, 11]],
                              [[6, 8, 11], [3, 6, 8, 11], [6, 8, 11]],
                              [[6, 9, 11], [3, 6, 9, 11], [6, 9, 11]], [[7], [2, 7, 11], [7]],
                              [[7, 9], [2, 6, 9], [2]], [[7, 10], [2, 7, 10], [7]],
                              [[7, 11], [2, 7, 11], [7]], [[7, 9, 11], [2, 7, 9, 11], [7, 9, 11]],
                              [[8], [3, 8], [8]], [[8, 10], [3, 7, 10], [3]], [[8, 11], [4, 8, 11], [4]],
                              [[9], [4, 9], [9]], [[9, 11], [4, 8, 11], [4]], [[10], [2, 5, 10], [10]],
                              [[11], [6, 11], [11]]]

#===============================================================================

ALL_CHORDS_TRIPLETS_FILTERED = [[[0], [0, 4, 7], [7]], [[0, 3], [0, 3, 7], [0]],
                                [[0, 3, 5], [0, 3, 5, 9], [5]], [[0, 3, 5, 8], [0, 3, 7, 10], [0]],
                                [[0, 3, 5, 9], [0, 3, 7, 10], [10]], [[0, 3, 5, 10], [0, 3, 5, 9], [5]],
                                [[0, 3, 7], [0, 3, 7, 10], [0]], [[0, 3, 7, 10], [0, 3, 5, 9], [2, 5, 10]],
                                [[0, 3, 8], [0, 3, 5, 8], [8]], [[0, 3, 9], [0, 3, 5, 9], [5]],
                                [[0, 3, 10], [0, 3, 7, 10], [0]], [[0, 4], [0, 4, 7], [0]],
                                [[0, 4, 6], [0, 4, 6, 9], [4]], [[0, 4, 6, 9], [1, 4, 6, 9], [9]],
                                [[0, 4, 6, 10], [0, 4, 7, 10], [0, 4, 10]], [[0, 4, 7], [0, 4, 7, 10], [0]],
                                [[0, 4, 7, 10], [1, 4, 7, 10], [0]], [[0, 4, 8], [0, 4, 7, 10], [0, 5, 8]],
                                [[0, 4, 9], [0, 4, 6, 9], [9]], [[0, 4, 10], [0, 4, 7, 10], [0]],
                                [[0, 5], [0, 5, 9], [5]], [[0, 5, 8], [0, 3, 5, 8], [5]],
                                [[0, 5, 9], [0, 3, 5, 9], [5]], [[0, 5, 10], [0, 3, 5, 10], [10]],
                                [[0, 6], [0, 6, 9], [9]], [[0, 6, 9], [0, 4, 6, 9], [6]],
                                [[0, 6, 10], [0, 4, 7, 10], [10]], [[0, 7], [0, 4, 7], [0]],
                                [[0, 7, 10], [0, 4, 7, 10], [0]], [[0, 8], [0, 3, 8], [8]],
                                [[0, 9], [0, 4, 9], [9]], [[0, 10], [2, 5, 10], [10]], [[1], [1, 8], [8]],
                                [[1, 4], [1, 4, 9], [9]], [[1, 4, 6], [1, 4, 6, 9], [6]],
                                [[1, 4, 6, 9], [1, 4, 8, 11], [4]], [[1, 4, 6, 10], [0, 3, 5, 9], [5]],
                                [[1, 4, 6, 11], [1, 4, 6, 9], [6]], [[1, 4, 7], [1, 4, 7, 10], [10]],
                                [[1, 4, 7, 10], [0, 4, 7, 10], [0]],
                                [[1, 4, 7, 11], [1, 4, 6, 10], [1, 6, 10]], [[1, 4, 8], [1, 4, 8, 11], [1]],
                                [[1, 4, 8, 11], [1, 4, 6, 9], [1, 4, 9]], [[1, 4, 9], [1, 4, 6, 9], [9]],
                                [[1, 4, 10], [1, 4, 6, 10], [6]], [[1, 4, 11], [1, 4, 8, 11], [1]],
                                [[1, 5], [1, 5, 8], [1]], [[1, 5, 8], [1, 5, 8, 11], [1]],
                                [[1, 5, 8, 11], [2, 5, 8, 11], [1]], [[1, 5, 9], [0, 3, 5, 9], [0, 5, 9]],
                                [[1, 5, 10], [0, 4, 7, 10], [0]], [[1, 5, 11], [1, 5, 8, 11], [11]],
                                [[1, 6], [1, 6, 10], [6]], [[1, 6, 9], [1, 4, 6, 9], [6]],
                                [[1, 6, 10], [1, 4, 6, 10], [6]], [[1, 6, 11], [1, 4, 6, 11], [11]],
                                [[1, 7], [1, 4, 7], [4]], [[1, 7, 10], [1, 4, 7, 10], [4]],
                                [[1, 7, 11], [1, 4, 7, 11], [7]], [[1, 8], [1, 5, 8], [1]],
                                [[1, 8, 11], [1, 4, 8, 11], [1]], [[1, 9], [1, 4, 9], [9]],
                                [[1, 10], [1, 5, 10], [10]], [[1, 11], [2, 6, 11], [11]], [[2], [2, 9], [9]],
                                [[2, 5], [2, 5, 9], [2]], [[2, 5, 8], [2, 5, 8, 11], [2]],
                                [[2, 5, 8, 11], [1, 4, 7, 10], [0, 3, 8]],
                                [[2, 5, 9], [0, 3, 5, 9], [2, 5, 10]], [[2, 5, 10], [0, 3, 5, 9], [2, 10]],
                                [[2, 5, 11], [2, 5, 8, 11], [8]], [[2, 6], [2, 6, 9], [2]],
                                [[2, 6, 9], [1, 4, 6, 9], [1, 4, 9]], [[2, 6, 10], [1, 4, 6, 10], [1, 6, 10]],
                                [[2, 6, 11], [1, 4, 6, 10], [1, 6, 10]], [[2, 7], [2, 7, 11], [7]],
                                [[2, 7, 10], [0, 4, 7, 10], [0]], [[2, 7, 11], [1, 4, 6, 9], [1, 4, 9]],
                                [[2, 8], [4, 8, 11], [4]], [[2, 8, 11], [2, 5, 8, 11], [4]],
                                [[2, 9], [2, 6, 9], [2]], [[2, 10], [2, 5, 10], [10]],
                                [[2, 11], [2, 7, 11], [7]], [[3], [3, 10], [10]], [[3, 5], [3, 7, 10], [3]],
                                [[3, 5, 8], [0, 3, 5, 8], [8]], [[3, 5, 8, 11], [2, 5, 8, 11], [2]],
                                [[3, 5, 9], [0, 3, 5, 9], [5]], [[3, 5, 10], [0, 3, 5, 10], [5, 10]],
                                [[3, 5, 11], [3, 5, 8, 11], [5]], [[3, 7], [3, 7, 10], [3]],
                                [[3, 7, 10], [0, 3, 7, 10], [10]], [[3, 7, 11], [0, 3, 7, 10], [3, 7, 10]],
                                [[3, 8], [0, 3, 8], [8]], [[3, 8, 11], [3, 5, 8, 11], [11]],
                                [[3, 9], [0, 3, 9], [9]], [[3, 10], [3, 7, 10], [3]],
                                [[3, 11], [3, 8, 11], [8]], [[4], [4, 11], [11]], [[4, 6], [4, 7, 11], [4]],
                                [[4, 6, 9], [1, 4, 6, 9], [9]], [[4, 6, 10], [1, 4, 6, 10], [6]],
                                [[4, 6, 11], [1, 4, 6, 11], [11]], [[4, 7], [0, 4, 7], [0]],
                                [[4, 7, 10], [0, 4, 7, 10], [0]], [[4, 7, 11], [1, 4, 7, 11], [11]],
                                [[4, 8], [4, 8, 11], [4]], [[4, 8, 11], [1, 4, 8, 11], [4]],
                                [[4, 9], [1, 4, 9], [9]], [[4, 10], [4, 7, 10], [7]],
                                [[4, 11], [4, 8, 11], [4]], [[5], [0, 5, 9], [0]], [[5, 8], [0, 5, 8], [5]],
                                [[5, 8, 11], [1, 5, 8, 11], [1]], [[5, 9], [0, 5, 9], [5]],
                                [[5, 10], [2, 5, 10], [10]], [[5, 11], [0, 5, 9], [5]], [[6], [1, 6], [1]],
                                [[6, 9], [2, 6, 9], [2]], [[6, 10], [1, 6, 10], [6]],
                                [[6, 11], [2, 6, 11], [11]], [[7], [2, 7, 11], [2]],
                                [[7, 10], [2, 7, 10], [7]], [[7, 11], [2, 7, 11], [7]], [[8], [3, 8], [3]],
                                [[8, 11], [4, 8, 11], [4]], [[9], [4, 9], [4]], [[10], [2, 5, 10], [5]],
                                [[11], [6, 11], [6]]]

#===============================================================================

ALL_CHORDS_FULL = [[0], [0, 3], [0, 3, 5], [0, 3, 5, 8], [0, 3, 5, 9], [0, 3, 5, 10], [0, 3, 6],
                  [0, 3, 6, 9], [0, 3, 6, 10], [0, 3, 7], [0, 3, 7, 10], [0, 3, 8], [0, 3, 9],
                  [0, 3, 10], [0, 4], [0, 4, 6], [0, 4, 6, 9], [0, 4, 6, 10], [0, 4, 7],
                  [0, 4, 7, 10], [0, 4, 8], [0, 4, 9], [0, 4, 10], [0, 5], [0, 5, 8], [0, 5, 9],
                  [0, 5, 10], [0, 6], [0, 6, 9], [0, 6, 10], [0, 7], [0, 7, 10], [0, 8], [0, 9],
                  [0, 10], [1], [1, 4], [1, 4, 6], [1, 4, 6, 9], [1, 4, 6, 10], [1, 4, 6, 11],
                  [1, 4, 7], [1, 4, 7, 10], [1, 4, 7, 11], [1, 4, 8], [1, 4, 8, 11], [1, 4, 9],
                  [1, 4, 10], [1, 4, 11], [1, 5], [1, 5, 8], [1, 5, 8, 11], [1, 5, 9],
                  [1, 5, 10], [1, 5, 11], [1, 6], [1, 6, 9], [1, 6, 10], [1, 6, 11], [1, 7],
                  [1, 7, 10], [1, 7, 11], [1, 8], [1, 8, 11], [1, 9], [1, 10], [1, 11], [2],
                  [2, 5], [2, 5, 8], [2, 5, 8, 11], [2, 5, 9], [2, 5, 10], [2, 5, 11], [2, 6],
                  [2, 6, 9], [2, 6, 10], [2, 6, 11], [2, 7], [2, 7, 10], [2, 7, 11], [2, 8],
                  [2, 8, 11], [2, 9], [2, 10], [2, 11], [3], [3, 5], [3, 5, 8], [3, 5, 8, 11],
                  [3, 5, 9], [3, 5, 10], [3, 5, 11], [3, 6], [3, 6, 9], [3, 6, 10], [3, 6, 11],
                  [3, 7], [3, 7, 10], [3, 7, 11], [3, 8], [3, 8, 11], [3, 9], [3, 10], [3, 11],
                  [4], [4, 6], [4, 6, 9], [4, 6, 10], [4, 6, 11], [4, 7], [4, 7, 10], [4, 7, 11],
                  [4, 8], [4, 8, 11], [4, 9], [4, 10], [4, 11], [5], [5, 8], [5, 8, 11], [5, 9],
                  [5, 10], [5, 11], [6], [6, 9], [6, 10], [6, 11], [7], [7, 10], [7, 11], [8],
                  [8, 11], [9], [10], [11]]

#===============================================================================

ALL_CHORDS_TRANS = [[0], [0, 4], [0, 4, 7], [0, 4, 8], [0, 5], [0, 6], [0, 7], [0, 8], [1], [1, 5],
                    [1, 5, 9], [1, 6], [1, 7], [1, 8], [1, 9], [2], [2, 6], [2, 6, 10], [2, 7],
                    [2, 8], [2, 9], [2, 10], [3], [3, 7], [3, 7, 11], [3, 8], [3, 9], [3, 10],
                    [3, 11], [4], [4, 7], [4, 7, 11], [4, 8], [4, 9], [4, 10], [4, 11], [5],
                    [5, 9], [5, 10], [5, 11], [6], [6, 10], [6, 11], [7], [7, 11], [8], [9], [10],
                    [11]]

#===============================================================================

CHORDS_TYPES = ['WHITE', 'BLACK', 'UNKNOWN', 'MIXED WHITE', 'MIXED BLACK', 'MIXED GRAY']

#===============================================================================

WHITE_NOTES = [0, 2, 4, 5, 7, 9, 11]

#===============================================================================

BLACK_NOTES = [1, 3, 6, 8, 10]

#===============================================================================

ALL_MELODIES = [['Arabian Nights', 'Verse', 'A', 'Minor',
                [[0, 13, 48], [13, 13, 50], [14, 27, 52], [28, 13, 48], [13, 13, 50],
                [14, 27, 52], [28, 13, 48], [13, 13, 52], [14, 19, 51], [20, 14, 47],
                [15, 19, 49], [19, 28, 51], [29, 13, 47], [14, 13, 51], [14, 20, 50],
                [20, 19, 50], [20, 18, 50], [18, 24, 50], [24, 27, 52], [28, 68, 48],
                [82, 13, 52], [14, 13, 53], [14, 20, 55], [20, 20, 51], [21, 14, 53],
                [14, 20, 55], [21, 20, 51], [20, 13, 55], [14, 20, 54], [21, 20, 50],
                [20, 13, 52], [14, 27, 54], [28, 13, 50], [14, 13, 54], [13, 20, 53],
                [21, 20, 53], [21, 13, 53], [13, 27, 53], [42, 13, 55], [14, 68, 52],
                [82, 13, 57], [14, 13, 59], [14, 27, 60], [27, 13, 57], [14, 13, 59],
                [14, 27, 60], [28, 13, 57], [13, 13, 59], [14, 27, 60], [28, 13, 57],
                [13, 13, 59], [14, 27, 60], [28, 13, 57], [14, 13, 59], [14, 27, 60],
                [27, 13, 57], [13, 13, 59], [14, 27, 60], [28, 27, 57], [28, 82, 52],
                [82, 13, 48], [14, 13, 50], [14, 27, 52], [28, 13, 48], [13, 13, 50],
                [14, 27, 52], [27, 13, 48], [14, 13, 52], [14, 19, 51], [19, 14, 47],
                [15, 19, 49], [20, 28, 51], [29, 13, 47], [14, 13, 51], [14, 20, 52],
                [20, 19, 52], [19, 18, 52], [19, 17, 60], [17, 20, 59], [21, 20, 57],
                [20, 62, 57]]],
              ['Beard Barb', 'Chorus', 'F', 'Major',
                [[0, 35, 81], [41, 42, 81], [42, 20, 83], [18, 20, 81], [19, 20, 79],
                [20, 21, 81], [20, 61, 79], [61, 12, 76], [10, 11, 74], [11, 65, 72],
                [82, 31, 81], [37, 43, 81], [42, 23, 83], [22, 20, 81], [20, 18, 79],
                [17, 22, 81], [22, 94, 79], [163, 32, 81], [39, 40, 81], [39, 23, 83],
                [21, 20, 81], [21, 20, 79], [18, 21, 81], [21, 82, 79], [83, 60, 72],
                [81, 30, 77], [29, 11, 76], [10, 21, 77], [22, 18, 81], [19, 22, 79],
                [21, 35, 81], [41, 11, 76], [9, 10, 74], [9, 77, 72]]],
              ['Beard Barb', 'Verse', 'A', 'Major',
                [[0, 27, 76], [39, 28, 74], [40, 28, 72], [39, 21, 69], [20, 10, 72],
                [12, 35, 67], [132, 20, 69], [19, 10, 72], [12, 29, 67], [49, 20, 69],
                [20, 10, 72], [9, 32, 67], [72, 20, 76], [19, 25, 77], [125, 35, 77],
                [42, 35, 74], [41, 34, 71], [40, 18, 76], [20, 11, 71], [11, 57, 72],
                [69, 18, 76], [20, 12, 69], [22, 11, 69], [12, 8, 71], [8, 11, 72],
                [13, 7, 71], [6, 11, 72], [13, 10, 69], [9, 17, 67], [17, 35, 76],
                [82, 12, 69], [13, 7, 71], [7, 13, 72], [12, 8, 71], [8, 11, 72],
                [12, 10, 69], [9, 16, 67], [18, 30, 76], [83, 13, 69], [13, 7, 71],
                [8, 10, 72], [10, 8, 71], [8, 10, 72], [11, 10, 69], [10, 17, 67],
                [19, 32, 76], [81, 5, 76], [13, 3, 76], [9, 5, 76], [13, 6, 76], [8, 5, 74],
                [14, 7, 74], [6, 13, 72]]],
              ['Blue Railcart', 'Chorus', 'B-', 'Minor',
                [[0, 23, 70], [26, 10, 65], [13, 10, 70], [13, 12, 68], [14, 12, 66],
                [13, 25, 63], [26, 16, 66], [13, 13, 65], [15, 24, 60], [25, 13, 66],
                [14, 13, 65], [14, 12, 61], [40, 12, 70], [12, 15, 69], [14, 13, 70],
                [13, 14, 72], [14, 12, 70], [13, 23, 66], [27, 13, 65], [13, 12, 73],
                [13, 12, 72], [13, 13, 73], [15, 34, 70], [56, 23, 70], [27, 13, 65],
                [13, 13, 70], [12, 14, 68], [13, 15, 66], [14, 26, 63], [26, 16, 66],
                [14, 13, 65], [14, 27, 60], [27, 14, 66], [12, 12, 65], [15, 13, 61],
                [25, 24, 70], [27, 15, 69], [13, 13, 70], [13, 14, 72], [14, 13, 70],
                [14, 24, 66], [26, 13, 65], [13, 11, 73], [13, 14, 72], [13, 12, 73],
                [14, 38, 70]]],
              ['Blue Railcart', 'Verse', 'E-', 'Minor',
                [[0, 11, 65], [13, 13, 70], [12, 13, 69], [13, 13, 70], [15, 14, 72],
                [12, 13, 70], [14, 13, 68], [13, 13, 70], [14, 24, 68], [26, 23, 66],
                [27, 36, 66], [56, 12, 63], [12, 13, 68], [13, 13, 67], [12, 13, 68],
                [15, 13, 70], [12, 12, 68], [14, 13, 63], [13, 14, 66], [15, 46, 65],
                [107, 11, 65], [12, 14, 70], [15, 14, 69], [12, 13, 70], [14, 15, 72],
                [13, 12, 70], [13, 14, 68], [13, 14, 66], [15, 29, 65], [27, 24, 63],
                [26, 14, 70], [55, 13, 65], [12, 13, 73], [13, 13, 72], [13, 12, 70],
                [13, 15, 69], [14, 13, 70], [14, 12, 72], [13, 13, 69], [14, 57, 70]]],
              ['Bremen Musicians', 'Verse', 'C', 'Major',
                [[0, 15, 60], [16, 15, 60], [15, 15, 60], [15, 15, 62], [15, 15, 64],
                [16, 15, 64], [15, 15, 60], [15, 15, 64], [16, 30, 67], [30, 30, 64],
                [31, 60, 67], [60, 15, 65], [16, 15, 65], [15, 15, 65], [15, 15, 64],
                [15, 15, 62], [16, 15, 62], [15, 15, 65], [15, 15, 69], [15, 30, 67],
                [31, 30, 65], [30, 61, 67], [61, 45, 64], [46, 15, 64], [15, 30, 67],
                [31, 30, 64], [31, 15, 69], [15, 15, 69], [15, 15, 69], [15, 15, 71],
                [16, 30, 72], [30, 30, 69], [31, 15, 74], [15, 15, 74], [15, 15, 74],
                [15, 15, 72], [16, 15, 71], [15, 15, 67], [15, 15, 71], [15, 15, 74],
                [16, 30, 72], [30, 30, 71], [31, 61, 69], [61, 45, 65], [45, 15, 65],
                [16, 30, 69], [30, 30, 72], [31, 30, 71], [30, 30, 69], [30, 30, 71],
                [31, 30, 74], [30, 15, 76], [16, 15, 74], [15, 45, 72]]],
              ['Chunga Changa', 'Chorus', 'G', 'Major',
                [[0, 7, 67], [16, 6, 72], [16, 15, 71], [20, 7, 69], [9, 7, 67], [17, 6, 69],
                [14, 19, 71], [24, 6, 69], [6, 6, 67], [16, 6, 69], [15, 21, 69],
                [22, 5, 67], [9, 6, 67], [14, 6, 69], [15, 21, 69], [23, 5, 67], [9, 6, 67],
                [15, 5, 69], [15, 21, 69], [23, 4, 67], [7, 6, 67], [15, 6, 69],
                [15, 21, 69], [22, 5, 67], [8, 5, 69], [15, 7, 71], [16, 19, 69],
                [22, 7, 67], [70, 7, 67], [15, 6, 72], [15, 20, 71], [21, 6, 69], [8, 5, 67],
                [16, 6, 69], [16, 21, 71], [23, 6, 69], [7, 5, 67], [14, 6, 69],
                [16, 21, 69], [24, 4, 67], [6, 6, 67], [15, 6, 69], [16, 19, 69],
                [22, 3, 67], [8, 6, 67], [15, 6, 69], [15, 22, 69], [24, 5, 67], [9, 7, 67],
                [15, 5, 69], [13, 22, 69], [23, 6, 67], [7, 7, 65], [17, 7, 64],
                [14, 20, 62], [24, 8, 60]]],
              ['Chunga Changa', 'Verse', 'C', 'Minor',
                [[0, 4, 60], [15, 5, 63], [14, 6, 67], [16, 5, 67], [46, 20, 67], [23, 6, 65],
                [6, 6, 67], [16, 7, 68], [14, 14, 67], [77, 23, 72], [30, 6, 63],
                [15, 6, 62], [16, 6, 62], [47, 16, 62], [20, 6, 63], [7, 7, 65], [17, 6, 67],
                [15, 13, 63], [91, 6, 60], [16, 6, 63], [14, 6, 67], [16, 6, 67],
                [47, 17, 67], [21, 6, 65], [7, 6, 67], [16, 7, 68], [17, 28, 67],
                [71, 22, 72], [32, 7, 63], [15, 7, 62], [16, 7, 62], [47, 15, 62],
                [22, 6, 63], [6, 9, 65], [17, 7, 67], [16, 12, 60]]],
              ['Clouds', 'Chorus', 'E', 'Minor',
                [[0, 15, 71], [13, 7, 76], [17, 6, 79], [15, 110, 83], [162, 5, 83],
                [17, 15, 83], [13, 16, 84], [15, 17, 83], [16, 14, 81], [14, 13, 79],
                [15, 45, 83], [45, 51, 78], [137, 16, 71], [14, 5, 75], [15, 6, 78],
                [17, 123, 81], [165, 16, 83], [15, 6, 81], [15, 15, 83], [15, 6, 84],
                [15, 5, 83], [15, 5, 81], [15, 38, 84], [45, 72, 83], [105, 16, 84],
                [15, 16, 83], [15, 16, 84], [15, 15, 83], [15, 16, 81], [15, 15, 80],
                [15, 30, 83], [30, 15, 81], [15, 76, 72], [135, 29, 83], [30, 30, 78],
                [30, 60, 81], [60, 59, 79], [90, 12, 81], [15, 18, 79], [15, 17, 81],
                [15, 17, 79], [15, 16, 78], [15, 16, 76], [15, 31, 83], [30, 15, 79],
                [15, 72, 76], [135, 31, 79], [30, 28, 75], [30, 85, 76]]],
              ['Clouds', 'Verse', 'E', 'Minor',
                [[0, 16, 71], [15, 15, 76], [15, 30, 79], [31, 16, 78], [14, 15, 76],
                [14, 15, 75], [14, 17, 76], [15, 18, 78], [17, 15, 75], [14, 71, 76],
                [89, 15, 71], [15, 17, 72], [17, 23, 74], [30, 5, 74], [14, 13, 74],
                [13, 15, 76], [15, 15, 74], [16, 16, 72], [15, 17, 74], [15, 31, 72],
                [32, 43, 71], [57, 17, 72], [17, 13, 71], [15, 27, 69], [28, 15, 72],
                [17, 15, 76], [15, 16, 81], [15, 17, 79], [15, 16, 78], [14, 14, 76],
                [15, 55, 79], [92, 17, 78], [15, 13, 76], [15, 30, 71], [30, 14, 76],
                [13, 17, 78], [16, 13, 79], [13, 16, 78], [16, 14, 81], [14, 17, 79],
                [16, 33, 78], [31, 20, 76]]],
              ['Daddys Song', 'Chorus', 'A-', 'Major',
                [[0, 7, 73], [15, 6, 68], [14, 15, 70], [14, 5, 68], [15, 7, 73], [14, 5, 68],
                [15, 14, 70], [14, 7, 68], [14, 15, 72], [29, 9, 72], [14, 4, 68],
                [15, 27, 70], [29, 13, 68], [28, 6, 72], [15, 5, 68], [14, 14, 70],
                [14, 6, 68], [15, 6, 72], [14, 5, 68], [15, 15, 70], [14, 6, 68],
                [29, 15, 70], [14, 14, 68], [14, 14, 66], [15, 29, 65], [29, 19, 68],
                [28, 6, 73], [15, 5, 68], [14, 16, 70], [14, 4, 68], [15, 5, 73],
                [14, 5, 68], [14, 14, 70], [15, 8, 68], [14, 18, 73], [29, 15, 73],
                [14, 14, 72], [15, 27, 75], [28, 19, 70], [29, 6, 73], [14, 16, 73],
                [15, 17, 72], [14, 17, 70], [14, 6, 72], [15, 18, 72], [14, 20, 70],
                [15, 11, 68], [28, 13, 66], [15, 15, 65], [14, 17, 63], [14, 34, 68],
                [58, 4, 73], [14, 16, 73], [14, 15, 72], [15, 15, 70], [14, 7, 72],
                [15, 16, 72], [14, 18, 70], [14, 13, 68], [29, 17, 68], [15, 17, 70],
                [14, 20, 72], [14, 16, 73]]],
              ['Daddys Song', 'Verse', 'C#', 'Minor',
                [[0, 23, 68], [29, 28, 68], [29, 30, 73], [29, 17, 68], [14, 13, 66],
                [14, 30, 64], [29, 27, 66], [29, 31, 64], [28, 29, 63], [29, 29, 66],
                [29, 31, 69], [29, 27, 68], [29, 13, 63], [14, 17, 64], [14, 31, 66],
                [29, 31, 68], [29, 35, 64], [57, 20, 68], [29, 24, 68], [29, 31, 73],
                [29, 10, 68], [14, 15, 69], [14, 27, 71], [29, 27, 73], [29, 28, 69],
                [29, 18, 66], [28, 27, 73], [29, 29, 69], [29, 28, 68], [28, 12, 66],
                [15, 13, 64], [14, 31, 66], [29, 27, 68], [29, 20, 61]]],
              ['Dreidel', 'Chorus', 'C', 'Major',
                [[0, 6, 64], [14, 8, 67], [17, 6, 64], [14, 7, 67], [15, 6, 64], [14, 7, 67],
                [17, 22, 64], [32, 6, 64], [15, 6, 67], [16, 6, 67], [14, 8, 65],
                [16, 6, 64], [16, 35, 62], [49, 6, 62], [14, 7, 65], [16, 6, 62],
                [14, 6, 65], [17, 6, 62], [15, 6, 65], [17, 20, 62], [30, 6, 62],
                [15, 7, 67], [15, 7, 65], [16, 7, 64], [15, 7, 62], [15, 26, 60]]],
              ['Dreidel', 'Verse', 'C', 'Major',
                [[0, 22, 55], [32, 6, 60], [15, 8, 60], [14, 8, 62], [15, 8, 62],
                [15, 12, 64], [17, 25, 60], [31, 8, 64], [15, 7, 67], [15, 8, 67],
                [15, 9, 65], [15, 8, 64], [17, 36, 62], [50, 6, 62], [14, 7, 62],
                [15, 7, 62], [15, 6, 64], [16, 6, 64], [15, 7, 65], [15, 21, 62],
                [32, 7, 62], [16, 7, 67], [16, 8, 65], [15, 8, 64], [15, 8, 62],
                [16, 41, 60]]],
              ['Duck Tales', 'Chorus', 'A', 'Major',
                [[0, 12, 68], [20, 11, 68], [31, 8, 59], [7, 22, 71], [21, 11, 68],
                [75, 25, 64], [28, 12, 62], [21, 14, 60], [19, 13, 62], [21, 14, 64],
                [20, 14, 62], [20, 14, 60], [20, 10, 62], [20, 13, 68], [22, 12, 68],
                [32, 8, 59], [7, 23, 71], [24, 13, 68], [73, 25, 64], [29, 13, 62],
                [19, 14, 60], [19, 12, 62], [20, 15, 64], [21, 12, 62], [20, 13, 60],
                [20, 12, 62], [22, 12, 68], [21, 12, 68]]],
              ['Duck Tales', 'Verse', 'F#', 'Major',
                [[0, 12, 52], [20, 13, 56], [22, 13, 59], [19, 11, 61], [20, 8, 62],
                [14, 10, 61], [20, 23, 61], [29, 10, 59], [20, 24, 57], [31, 30, 56],
                [51, 23, 57], [32, 24, 56], [48, 15, 52], [21, 17, 56], [21, 14, 59],
                [20, 14, 61], [20, 9, 62], [14, 12, 61], [19, 16, 61], [22, 16, 59],
                [28, 24, 62], [30, 28, 61], [49, 26, 62], [34, 26, 61], [69, 16, 54],
                [21, 13, 57], [21, 12, 61], [20, 26, 61], [34, 28, 59], [67, 15, 61],
                [21, 14, 64], [20, 13, 66], [21, 26, 68], [32, 7, 66], [12, 15, 66]]],
              ['Eagles Learn to Fly', 'Verse', 'F#', 'Minor',
                [[0, 28, 68], [29, 17, 73], [14, 15, 68], [43, 12, 66], [21, 9, 66],
                [8, 16, 64], [14, 14, 63], [14, 33, 61], [73, 14, 61], [14, 15, 64],
                [14, 17, 68], [14, 40, 73], [44, 14, 68], [14, 48, 73], [43, 14, 68],
                [15, 27, 71], [28, 36, 66], [43, 16, 59], [15, 15, 62], [14, 5, 66],
                [15, 41, 71], [43, 14, 66], [14, 27, 71], [29, 29, 73], [29, 29, 69],
                [28, 34, 64], [44, 7, 73], [14, 8, 73], [14, 15, 73], [15, 67, 71],
                [72, 15, 71], [14, 14, 69], [14, 14, 68], [15, 13, 66], [28, 26, 68],
                [29, 14, 69], [29, 26, 68], [29, 15, 73], [14, 20, 68], [43, 14, 66],
                [22, 8, 66], [7, 14, 64], [14, 15, 63], [15, 28, 61]]],
              ['Freak', 'Chorus', 'D', 'Minor',
                [[0, 17, 76], [19, 6, 81], [19, 20, 81], [37, 4, 69], [8, 9, 69],
                [11, 23, 77], [28, 14, 74], [28, 17, 74], [19, 6, 79], [17, 18, 79],
                [20, 18, 74], [19, 21, 77], [19, 37, 76], [39, 6, 73], [17, 20, 79],
                [18, 19, 77], [18, 12, 74], [59, 17, 76], [19, 14, 72], [56, 17, 76],
                [16, 6, 74], [19, 6, 71], [20, 18, 72], [17, 25, 69]]],
              ['Freak', 'Verse', 'C', 'Minor',
                [[0, 19, 76], [18, 20, 77], [19, 21, 76], [21, 17, 72], [17, 18, 69],
                [20, 33, 72], [35, 19, 71], [20, 21, 74], [19, 20, 76], [19, 20, 74],
                [20, 17, 71], [17, 20, 74], [20, 35, 77], [36, 17, 76], [18, 19, 79],
                [19, 18, 81], [18, 20, 79], [21, 19, 76], [20, 17, 72], [18, 34, 76],
                [37, 6, 74], [17, 18, 74], [20, 19, 76], [19, 18, 74], [20, 17, 76],
                [17, 20, 77], [19, 37, 79]]],
              ['Friend Song', 'Chorus', 'A', 'Minor',
                [[0, 14, 71], [13, 15, 69], [14, 18, 62], [28, 15, 62], [13, 11, 65],
                [14, 27, 69], [28, 14, 67], [14, 11, 65], [14, 6, 64], [13, 6, 64],
                [14, 16, 64], [14, 14, 69], [14, 29, 72], [41, 15, 72], [14, 5, 71],
                [14, 3, 71], [13, 12, 71], [14, 12, 67], [14, 27, 69], [28, 26, 71],
                [27, 40, 72], [56, 26, 71], [27, 27, 69], [28, 16, 62], [27, 12, 62],
                [14, 12, 65], [14, 27, 69], [28, 14, 67], [13, 13, 65], [14, 6, 64],
                [14, 6, 64], [14, 14, 64], [14, 12, 69], [14, 27, 72], [41, 13, 72],
                [14, 4, 71], [14, 3, 71], [14, 13, 71], [14, 12, 74], [13, 17, 72],
                [28, 24, 71], [28, 11, 69]]],
              ['Friend Song', 'Verse', 'A', 'Minor',
                [[0, 3, 69], [14, 3, 71], [14, 13, 72], [13, 4, 74], [14, 4, 72], [14, 4, 71],
                [14, 4, 69], [55, 54, 64], [55, 23, 60], [27, 4, 69], [14, 4, 71],
                [14, 54, 72], [55, 51, 74], [56, 24, 72], [27, 31, 71], [28, 25, 59],
                [27, 5, 67], [14, 4, 69], [14, 13, 71], [14, 3, 72], [14, 5, 71],
                [13, 5, 69], [14, 6, 68], [55, 55, 65], [55, 18, 64], [28, 3, 68],
                [14, 4, 69], [13, 52, 71], [56, 52, 72], [55, 22, 71], [27, 26, 69],
                [28, 26, 57]]],
              ['Gang Dance', 'Chorus', 'D', 'Minor',
                [[0, 11, 64], [21, 23, 64], [25, 7, 70], [49, 6, 69], [23, 23, 69],
                [24, 12, 64], [68, 43, 65], [45, 6, 64], [23, 8, 65], [14, 7, 64],
                [10, 6, 65], [11, 8, 67], [12, 13, 69], [50, 7, 67], [24, 25, 67],
                [22, 11, 74], [48, 6, 73], [23, 25, 73], [24, 10, 69], [47, 6, 74],
                [23, 54, 74]]],
              ['Gang Dance', 'Verse', 'D', 'Minor',
                [[0, 27, 69], [35, 5, 68], [10, 27, 69], [35, 6, 68], [10, 9, 69],
                [24, 11, 65], [24, 12, 64], [22, 11, 62], [49, 43, 67], [47, 6, 62],
                [25, 5, 67], [11, 5, 67], [12, 6, 67], [10, 7, 69], [12, 13, 67],
                [72, 43, 67], [46, 7, 60], [24, 7, 67], [20, 23, 70], [25, 11, 69],
                [22, 15, 67], [24, 9, 65], [24, 8, 65], [48, 4, 65], [11, 4, 65],
                [11, 5, 65], [12, 5, 65], [11, 6, 65], [12, 9, 67], [13, 12, 65]]],
              ['Gang Song', 'Chorus', 'C', 'Minor',
                [[0, 24, 62], [38, 22, 62], [38, 25, 62], [38, 23, 63], [37, 24, 60],
                [38, 24, 55], [38, 9, 63], [19, 11, 63], [19, 12, 62], [19, 9, 63],
                [19, 30, 65], [38, 25, 65], [38, 32, 65], [38, 27, 65], [38, 28, 67],
                [37, 14, 55], [39, 6, 67], [18, 12, 67], [19, 14, 65], [19, 10, 67],
                [19, 31, 68], [38, 10, 70], [19, 22, 72], [38, 13, 72], [19, 9, 70],
                [19, 9, 68], [19, 30, 67], [38, 10, 68], [19, 22, 70], [37, 11, 70],
                [19, 10, 68], [20, 11, 67], [18, 20, 65], [19, 10, 64], [19, 12, 65],
                [19, 11, 68], [19, 30, 67], [38, 13, 67], [19, 11, 67], [19, 34, 65],
                [38, 71, 63]]],
              ['Gang Song', 'Verse', 'C', 'Minor',
                [[0, 9, 55], [19, 13, 60], [19, 12, 62], [19, 12, 63], [19, 10, 60],
                [19, 15, 59], [19, 10, 60], [19, 11, 62], [19, 11, 59], [19, 32, 60],
                [95, 11, 60], [18, 11, 63], [19, 10, 67], [20, 41, 72], [56, 12, 72],
                [19, 13, 70], [19, 14, 68], [19, 12, 67], [19, 13, 65], [19, 19, 68],
                [19, 41, 67], [114, 9, 67], [19, 14, 70], [18, 10, 68], [19, 11, 65],
                [20, 13, 62], [18, 12, 60], [19, 10, 59], [19, 14, 67], [19, 13, 65],
                [19, 27, 63], [133, 13, 60], [19, 14, 62], [19, 9, 62], [19, 15, 62],
                [56, 8, 62], [20, 14, 62], [18, 11, 63], [19, 13, 62], [19, 17, 60]]],
              ['Gang Stop', 'Chorus', 'F', 'Minor',
                [[0, 13, 72], [25, 3, 67], [13, 13, 63], [25, 2, 62], [13, 14, 60],
                [27, 14, 72], [25, 2, 67], [12, 12, 63], [26, 3, 62], [12, 14, 60],
                [26, 4, 72], [13, 2, 72], [5, 2, 72], [6, 2, 72], [13, 3, 72], [13, 24, 73],
                [26, 19, 72], [27, 12, 73], [14, 4, 72], [13, 3, 68], [12, 3, 67],
                [12, 46, 65], [54, 23, 68], [25, 2, 65], [14, 24, 68], [27, 2, 65],
                [12, 9, 68], [11, 3, 65], [12, 24, 68], [27, 2, 65], [14, 22, 68],
                [25, 3, 65], [13, 10, 68], [12, 2, 65], [13, 3, 67], [13, 1, 67], [6, 2, 67],
                [5, 2, 67], [14, 2, 67], [12, 24, 68], [27, 17, 67], [27, 24, 63],
                [27, 21, 62], [26, 32, 60]]],
              ['Gang Stop', 'Verse', 'F', 'Minor',
                [[0, 14, 66], [26, 3, 67], [14, 12, 68], [25, 3, 67], [13, 3, 66],
                [14, 2, 67], [12, 12, 70], [24, 4, 69], [15, 13, 68], [26, 3, 67],
                [13, 2, 66], [13, 2, 67], [11, 22, 70], [26, 2, 69], [13, 12, 68],
                [26, 3, 67], [11, 2, 66], [13, 2, 67], [12, 18, 67], [28, 22, 60],
                [25, 42, 59], [54, 21, 68], [25, 3, 65], [14, 13, 68], [25, 9, 65],
                [12, 9, 68], [12, 3, 65], [13, 22, 68], [26, 2, 65], [15, 12, 68],
                [24, 8, 65], [12, 11, 68], [14, 3, 65], [12, 23, 68], [25, 3, 65],
                [14, 23, 68], [25, 11, 65], [14, 10, 68], [11, 10, 65], [12, 24, 62],
                [27, 22, 67], [26, 23, 63], [26, 16, 60]]],
              ['Grasshopper', 'Chorus', 'B-', 'Minor',
                [[0, 6, 70], [19, 6, 72], [19, 4, 72], [9, 5, 72], [10, 6, 72], [18, 5, 72],
                [19, 6, 73], [19, 4, 73], [9, 5, 73], [10, 6, 73], [18, 6, 73], [19, 10, 73],
                [19, 7, 72], [19, 7, 70], [18, 7, 69], [19, 7, 70], [19, 9, 70], [37, 6, 70],
                [19, 6, 72], [19, 4, 72], [9, 6, 72], [10, 7, 72], [18, 6, 72], [19, 6, 73],
                [19, 4, 73], [9, 5, 73], [10, 7, 73], [18, 5, 73], [19, 8, 73], [19, 7, 72],
                [19, 7, 70], [18, 7, 69], [19, 9, 70]]],
              ['Grasshopper', 'Verse', 'F', 'Minor',
                [[0, 8, 70], [19, 10, 65], [19, 9, 70], [19, 9, 65], [18, 7, 70], [19, 9, 69],
                [19, 10, 69], [37, 8, 69], [19, 11, 65], [19, 9, 69], [19, 9, 65],
                [18, 9, 69], [19, 9, 70], [19, 10, 70], [37, 7, 70], [19, 11, 65],
                [19, 8, 70], [19, 9, 65], [18, 8, 70], [19, 9, 69], [19, 9, 69], [37, 8, 69],
                [19, 9, 65], [19, 8, 69], [19, 9, 65], [18, 8, 69], [19, 14, 70]]],
              ['Gummy Bears', 'Chorus', 'B-', 'Major',
                [[0, 18, 74], [24, 8, 75], [14, 36, 77], [40, 26, 77], [35, 9, 77],
                [15, 8, 77], [13, 7, 77], [13, 10, 77], [13, 8, 75], [13, 7, 74],
                [13, 8, 72], [13, 20, 74], [23, 10, 77], [14, 33, 70], [38, 11, 70],
                [26, 4, 70], [14, 7, 77], [12, 7, 77], [13, 7, 77], [14, 9, 77], [13, 8, 75],
                [13, 8, 74], [12, 10, 72], [12, 5, 70], [26, 5, 77], [18, 8, 74], [8, 5, 70],
                [25, 4, 74], [26, 4, 70], [14, 10, 75], [13, 11, 74], [15, 22, 72],
                [27, 23, 74], [35, 10, 70], [27, 9, 70], [23, 10, 70], [26, 10, 70],
                [26, 9, 70], [26, 10, 70], [25, 11, 70], [26, 11, 70]]],
              ['Gummy Bears', 'Verse', 'B-', 'Major',
                [[0, 12, 62], [19, 12, 58], [18, 10, 62], [16, 12, 65], [18, 11, 62],
                [16, 10, 65], [16, 14, 67], [17, 12, 69], [17, 11, 70], [17, 21, 65],
                [26, 9, 62], [25, 12, 67], [18, 14, 65], [19, 10, 63], [16, 12, 65],
                [18, 12, 63], [17, 8, 62], [16, 12, 63], [18, 10, 62], [17, 10, 60],
                [16, 27, 65], [50, 14, 62], [21, 12, 58], [17, 11, 62], [16, 13, 65],
                [18, 11, 62], [17, 12, 65], [16, 14, 67], [17, 16, 69], [16, 13, 70],
                [17, 13, 65], [18, 12, 62], [16, 10, 58], [17, 13, 67], [18, 13, 65],
                [17, 14, 63], [18, 11, 65], [16, 11, 62], [19, 11, 65], [16, 13, 67],
                [17, 12, 69], [16, 11, 70], [17, 32, 72]]],
              ['Hava Nagilah', 'Chorus', 'C', 'Minor',
                [[0, 9, 66], [24, 35, 66], [50, 10, 63], [24, 10, 62], [25, 8, 62],
                [25, 46, 62], [49, 7, 63], [25, 35, 63], [49, 12, 62], [12, 10, 63],
                [13, 10, 60], [24, 5, 60], [25, 29, 60], [49, 41, 60], [50, 30, 63],
                [37, 8, 62], [12, 9, 60], [23, 12, 60], [23, 34, 67], [46, 42, 66],
                [46, 8, 63], [11, 9, 66], [11, 9, 63], [12, 11, 62], [11, 69, 66]]],
              ['Hava Nagilah', 'Verse', 'D', 'Minor',
                [[0, 34, 62], [49, 69, 62], [74, 18, 66], [25, 18, 63], [25, 17, 62],
                [24, 36, 66], [50, 66, 66], [74, 22, 69], [24, 14, 67], [25, 17, 66],
                [25, 36, 67], [49, 69, 67], [74, 21, 70], [25, 20, 69], [25, 17, 67],
                [24, 48, 66], [50, 10, 63], [12, 8, 66], [12, 11, 63], [25, 83, 62]]],
              ['It Too Shall Pass', 'Verse', 'C', 'Minor',
                [[0, 4, 75], [18, 4, 72], [18, 4, 79], [36, 4, 75], [18, 4, 72], [18, 6, 79],
                [36, 4, 72], [18, 4, 74], [18, 3, 75], [18, 4, 77], [18, 4, 75], [36, 4, 74],
                [36, 4, 74], [18, 4, 71], [18, 4, 79], [36, 4, 74], [18, 6, 71], [18, 4, 79],
                [36, 4, 74], [18, 3, 75], [18, 4, 77], [18, 4, 79], [18, 4, 77], [36, 3, 75],
                [36, 4, 79], [18, 6, 76], [18, 4, 84], [36, 4, 79], [18, 6, 76], [18, 4, 84],
                [36, 6, 79], [18, 4, 80], [18, 4, 82], [18, 4, 84], [18, 4, 82],
                [36, 12, 80], [36, 4, 80], [18, 6, 84], [1, 12, 84], [17, 6, 82],
                [18, 4, 80], [19, 3, 80], [35, 6, 79], [36, 4, 77], [1, 17, 77], [17, 5, 80],
                [18, 9, 79], [18, 6, 74], [18, 4, 75], [72, 4, 80], [18, 6, 84], [18, 4, 82],
                [18, 4, 80], [18, 4, 80], [36, 4, 79], [36, 4, 77], [18, 6, 80], [18, 4, 79],
                [18, 4, 71], [18, 3, 72]]],
              ['Learn at School', 'Chorus', 'E', 'Minor',
                [[0, 14, 64], [14, 8, 74], [15, 15, 74], [14, 7, 72], [15, 17, 72],
                [15, 9, 71], [14, 24, 71], [29, 12, 64], [15, 9, 72], [14, 18, 72],
                [15, 8, 71], [14, 16, 71], [15, 6, 69], [15, 30, 69], [29, 16, 67],
                [14, 18, 69], [15, 14, 72], [14, 17, 71], [15, 13, 67], [14, 14, 64],
                [15, 16, 67], [15, 16, 66], [14, 18, 71], [15, 16, 63], [14, 29, 66],
                [29, 36, 64]]],
              ['Learn at School', 'Verse', 'E', 'Minor',
                [[0, 15, 59], [15, 9, 67], [14, 18, 67], [15, 8, 66], [14, 16, 66],
                [15, 7, 64], [14, 19, 64], [29, 14, 59], [15, 8, 67], [15, 15, 67],
                [14, 8, 66], [15, 17, 66], [14, 7, 64], [15, 19, 64], [29, 14, 64],
                [15, 15, 67], [14, 8, 71], [15, 13, 71], [14, 17, 69], [15, 18, 67],
                [14, 8, 71], [15, 17, 71], [15, 14, 69], [14, 18, 67], [15, 31, 69],
                [29, 46, 71]]],
              ['Let Them Run', 'Chorus', 'E', 'Minor',
                [[0, 7, 61], [15, 11, 61], [17, 9, 64], [15, 30, 64], [32, 28, 63],
                [59, 10, 63], [14, 8, 66], [15, 26, 66], [31, 32, 64], [61, 12, 64],
                [14, 8, 68], [15, 30, 68], [33, 28, 66], [60, 12, 69], [14, 12, 68],
                [17, 45, 71], [90, 11, 68], [14, 10, 71], [18, 30, 71], [33, 24, 69],
                [59, 11, 66], [16, 8, 69], [16, 29, 69], [31, 23, 68], [62, 11, 64],
                [13, 10, 68], [15, 54, 66], [61, 56, 68], [62, 14, 61]]],
              ['Let Them Run', 'Verse', 'C#', 'Minor',
                [[0, 7, 68], [15, 7, 69], [16, 13, 68], [30, 9, 61], [14, 7, 63], [16, 9, 64],
                [15, 6, 61], [16, 8, 68], [15, 7, 69], [14, 17, 68], [29, 8, 63],
                [14, 8, 64], [18, 10, 66], [15, 5, 63], [16, 8, 68], [15, 9, 69],
                [15, 20, 68], [31, 8, 63], [15, 6, 64], [16, 18, 66], [30, 7, 68],
                [13, 10, 69], [16, 38, 68], [93, 7, 73], [14, 9, 74], [17, 19, 73],
                [31, 8, 68], [14, 9, 69], [16, 11, 71], [15, 7, 68], [16, 8, 73],
                [15, 8, 74], [15, 19, 73], [32, 10, 66], [14, 8, 68], [14, 10, 69],
                [17, 10, 73], [16, 11, 71], [16, 8, 69], [16, 19, 73], [29, 10, 68],
                [16, 8, 64], [15, 20, 63], [30, 10, 66], [16, 10, 64], [15, 60, 61]]],
              ['Lullaby', 'Chorus', 'E-', 'Major',
                [[0, 22, 70], [30, 31, 70], [30, 30, 72], [30, 29, 70], [30, 25, 75],
                [29, 32, 75], [31, 31, 72], [30, 25, 70], [44, 21, 63], [30, 16, 63],
                [16, 27, 68], [29, 31, 70], [30, 25, 72], [29, 32, 72], [31, 30, 70],
                [30, 30, 68], [32, 20, 67], [29, 32, 67], [30, 30, 68], [30, 33, 67],
                [31, 87, 70], [120, 59, 68], [59, 57, 65], [60, 80, 63]]],
              ['Lullaby', 'Verse', 'E-', 'Major',
                [[0, 27, 70], [25, 19, 67], [16, 45, 70], [44, 16, 67], [15, 26, 70],
                [30, 32, 70], [31, 28, 68], [29, 31, 67], [32, 30, 65], [30, 30, 67],
                [30, 67, 70], [180, 46, 70], [45, 15, 65], [14, 45, 70], [46, 16, 65],
                [14, 32, 70], [32, 30, 68], [29, 29, 67], [28, 31, 65], [30, 29, 63],
                [30, 32, 67], [31, 66, 70]]],
              ['Mamonthy Song', 'Chorus', 'F', 'Minor',
                [[0, 15, 72], [14, 15, 77], [14, 7, 79], [15, 5, 80], [14, 25, 79],
                [28, 14, 77], [29, 15, 72], [14, 15, 77], [14, 5, 79], [15, 5, 80],
                [14, 30, 79], [28, 11, 77], [29, 14, 72], [14, 15, 77], [14, 5, 79],
                [14, 7, 80], [15, 29, 79], [28, 24, 77], [29, 15, 72], [14, 16, 75],
                [14, 11, 73], [14, 8, 72], [14, 27, 75], [29, 19, 73], [28, 14, 73],
                [15, 16, 82], [14, 15, 80], [14, 16, 82], [14, 30, 80], [29, 26, 79],
                [28, 7, 77], [14, 29, 77], [29, 24, 72], [71, 6, 72], [14, 17, 72],
                [15, 15, 76], [14, 15, 79], [14, 30, 82], [29, 26, 80], [29, 15, 79],
                [15, 15, 80], [16, 12, 79], [12, 31, 77]]],
              ['Mamonthy Song', 'Verse', 'A-', 'Major',
                [[0, 15, 72], [14, 4, 75], [14, 4, 75], [14, 3, 75], [15, 28, 75],
                [28, 30, 77], [29, 15, 72], [14, 5, 75], [14, 4, 75], [14, 4, 75],
                [15, 29, 75], [57, 13, 68], [14, 9, 77], [14, 4, 77], [14, 4, 77],
                [14, 27, 77], [29, 28, 80], [28, 14, 79], [15, 16, 77], [14, 5, 75],
                [14, 3, 75], [14, 20, 75], [57, 16, 75], [15, 16, 80], [14, 15, 79],
                [14, 11, 80], [14, 30, 79], [29, 30, 77], [28, 16, 79], [15, 30, 77],
                [28, 27, 75], [71, 13, 75], [14, 15, 80], [15, 14, 70], [14, 15, 72],
                [14, 30, 73], [29, 28, 77], [28, 16, 75], [14, 27, 73], [29, 34, 72]]],
              ['New Year Song', 'Verse', 'C', 'Major',
                [[0, 49, 79], [53, 8, 76], [27, 25, 76], [27, 50, 79], [53, 7, 76],
                [27, 13, 76], [27, 23, 79], [26, 26, 77], [27, 22, 76], [27, 25, 74],
                [27, 80, 72], [107, 45, 81], [53, 19, 84], [27, 18, 81], [26, 45, 79],
                [54, 8, 76], [27, 17, 76], [26, 27, 79], [27, 26, 77], [27, 23, 76],
                [26, 28, 74], [27, 87, 72], [108, 46, 81], [53, 16, 84], [27, 17, 81],
                [27, 46, 79], [53, 7, 76], [27, 16, 76], [26, 28, 79], [27, 27, 77],
                [27, 29, 76], [27, 28, 74], [26, 52, 72]]],
              ['Open Secret', 'Chorus', 'G', 'Minor',
                [[0, 4, 79], [12, 3, 84], [13, 13, 83], [26, 4, 77], [13, 4, 80],
                [13, 11, 79], [25, 4, 79], [13, 4, 84], [13, 13, 83], [26, 4, 77],
                [12, 3, 80], [13, 14, 79], [25, 5, 79], [14, 4, 84], [13, 4, 83],
                [13, 4, 83], [13, 4, 79], [12, 3, 83], [13, 2, 84], [11, 4, 84], [13, 4, 84],
                [13, 6, 86], [13, 10, 87], [12, 6, 86], [9, 4, 86], [3, 7, 84], [15, 4, 83],
                [13, 8, 84]]],
              ['Open Secret', 'Verse', 'E-', 'Minor',
                [[0, 15, 79], [51, 13, 79], [52, 4, 79], [12, 4, 79], [13, 14, 80],
                [13, 3, 75], [13, 14, 79], [13, 3, 77], [13, 12, 77], [26, 15, 77],
                [51, 15, 77], [52, 4, 77], [13, 5, 80], [13, 12, 79], [13, 5, 74],
                [12, 12, 77], [13, 3, 75], [13, 11, 75], [26, 15, 75], [52, 15, 75],
                [51, 3, 75], [13, 4, 75], [13, 12, 77], [13, 4, 75], [13, 4, 74],
                [13, 4, 72], [12, 51, 82], [52, 14, 80], [39, 5, 84], [13, 3, 82],
                [13, 4, 80], [13, 10, 79], [13, 4, 77], [13, 3, 75], [13, 5, 74],
                [12, 7, 72]]],
              ['Righteous Road', 'Chorus', 'E-', 'Minor',
                [[0, 20, 67], [18, 23, 68], [19, 19, 70], [17, 36, 71], [35, 37, 68],
                [35, 23, 64], [20, 38, 65], [36, 19, 71], [19, 4, 70], [18, 5, 70],
                [16, 4, 66], [19, 5, 66], [18, 9, 63], [17, 28, 63], [38, 6, 63],
                [17, 21, 63], [18, 17, 62], [16, 21, 63], [18, 22, 65], [18, 21, 66],
                [18, 20, 68], [18, 23, 70], [18, 22, 68], [18, 7, 66], [19, 6, 66],
                [19, 5, 58], [19, 18, 58], [17, 9, 63]]],
              ['Righteous Road', 'Verse', 'E-', 'Minor',
                [[0, 5, 66], [18, 21, 66], [20, 6, 65], [17, 5, 65], [18, 5, 65],
                [18, 22, 65], [19, 19, 66], [35, 21, 66], [20, 20, 68], [16, 20, 66],
                [18, 21, 65], [18, 6, 63], [18, 24, 63], [20, 21, 58], [36, 19, 58],
                [18, 19, 63], [18, 18, 62], [17, 20, 63], [17, 21, 65], [19, 21, 66],
                [19, 20, 65], [16, 21, 66], [19, 20, 68], [18, 20, 70], [18, 21, 71],
                [17, 19, 70], [16, 22, 68], [20, 23, 70]]],
              ['Snow Maiden', 'Chorus', 'G', 'Major',
                [[0, 17, 62], [26, 26, 62], [27, 10, 70], [54, 25, 67], [29, 21, 60],
                [24, 12, 69], [54, 22, 65], [23, 25, 58], [30, 12, 67], [13, 11, 65],
                [27, 10, 64], [13, 26, 67], [14, 12, 65], [13, 15, 65], [105, 14, 60],
                [27, 6, 58], [13, 6, 58], [13, 18, 58], [54, 16, 62], [26, 6, 60],
                [14, 9, 60], [13, 17, 60], [54, 19, 64], [26, 6, 62], [14, 13, 62],
                [13, 21, 61], [26, 12, 59], [14, 10, 61], [13, 12, 62]]],
              ['Snow Maiden', 'Verse', 'D', 'Major',
                [[0, 6, 66], [13, 5, 66], [14, 4, 69], [13, 5, 69], [13, 28, 69], [25, 5, 67],
                [15, 5, 67], [12, 17, 71], [27, 27, 71], [28, 26, 69], [53, 9, 66],
                [14, 8, 66], [13, 3, 69], [12, 6, 69], [14, 25, 69], [27, 6, 67],
                [14, 6, 67], [13, 19, 71], [27, 15, 71], [13, 29, 69], [67, 5, 66],
                [14, 4, 66], [13, 4, 66], [13, 4, 66], [13, 23, 66], [27, 5, 62],
                [14, 4, 62], [13, 12, 64], [27, 22, 64], [26, 15, 62], [53, 4, 62],
                [13, 4, 62], [14, 5, 62], [13, 7, 64], [13, 20, 66], [27, 5, 62],
                [13, 5, 62], [14, 17, 62], [26, 20, 61], [27, 12, 62]]],
              ['Sun Circle', 'Chorus', 'G', 'Major',
                [[0, 17, 62], [30, 16, 62], [29, 51, 67], [60, 20, 69], [30, 21, 71],
                [30, 21, 69], [30, 12, 67], [30, 14, 62], [29, 16, 62], [30, 51, 67],
                [60, 21, 69], [30, 21, 71], [29, 19, 71], [30, 14, 69], [30, 18, 62],
                [30, 20, 62], [30, 51, 69], [59, 21, 71], [30, 20, 72], [30, 22, 74],
                [30, 18, 69], [30, 19, 69], [30, 18, 71], [30, 54, 72], [59, 20, 67],
                [30, 18, 69], [30, 49, 71]]],
              ['Sun Circle', 'Verse', 'G', 'Minor',
                [[0, 29, 62], [29, 20, 63], [20, 9, 62], [9, 58, 67], [59, 31, 69],
                [31, 22, 70], [21, 8, 69], [8, 44, 62], [60, 27, 62], [29, 17, 70],
                [21, 4, 70], [7, 31, 70], [30, 21, 69], [22, 2, 69], [8, 30, 67],
                [32, 67, 66], [91, 28, 65], [29, 21, 67], [21, 7, 65], [8, 55, 70],
                [60, 30, 72], [29, 23, 74], [22, 6, 72], [7, 48, 65], [62, 28, 65],
                [29, 17, 69], [18, 8, 70], [10, 30, 72], [31, 15, 70], [17, 13, 72],
                [15, 45, 74]]],
              ['Sunbath', 'Verse', 'F', 'Major',
                [[0, 11, 72], [19, 10, 70], [11, 9, 69], [31, 8, 65], [31, 7, 62],
                [29, 7, 64], [19, 105, 65], [106, 12, 72], [20, 12, 70], [10, 11, 69],
                [32, 9, 65], [30, 10, 62], [32, 8, 64], [19, 95, 65], [105, 9, 69],
                [18, 13, 72], [12, 87, 67], [96, 10, 69], [18, 11, 72], [10, 86, 65],
                [94, 11, 67], [20, 8, 69], [11, 8, 70], [32, 9, 67], [30, 10, 64],
                [31, 10, 67], [17, 101, 65], [107, 10, 69], [22, 11, 72], [13, 86, 67],
                [91, 10, 69], [21, 12, 72], [11, 80, 65], [91, 9, 67], [20, 8, 69],
                [11, 7, 70], [32, 7, 67], [31, 9, 64], [31, 9, 67], [18, 79, 65]]],
              ['Tail Spin', 'Chorus', 'G', 'Major',
                [[0, 6, 67], [16, 8, 71], [16, 6, 62], [16, 5, 65], [8, 5, 67], [15, 4, 67],
                [8, 6, 71], [16, 5, 62], [16, 5, 65], [16, 5, 67], [16, 7, 71], [16, 5, 62],
                [15, 5, 65], [8, 6, 67], [19, 7, 67], [16, 7, 67], [15, 14, 67], [21, 6, 67],
                [16, 7, 71], [16, 6, 62], [16, 5, 65], [8, 5, 67], [16, 3, 67], [8, 6, 71],
                [15, 5, 62], [16, 5, 65], [16, 5, 67], [16, 7, 71], [16, 5, 62], [15, 5, 65],
                [8, 6, 67]]],
              ['Tail Spin', 'Verse', 'C', 'Major',
                [[0, 14, 62], [14, 17, 67], [16, 17, 64], [32, 3, 64], [8, 6, 64],
                [16, 25, 66], [41, 15, 60], [15, 17, 64], [15, 17, 62], [30, 2, 62],
                [10, 6, 62], [16, 22, 64], [71, 4, 60], [8, 5, 60], [15, 7, 60], [16, 6, 64],
                [17, 7, 64], [17, 6, 62], [16, 7, 62], [21, 2, 62], [8, 3, 62], [8, 7, 64],
                [14, 3, 64], [10, 6, 66], [13, 5, 66], [9, 13, 67]]],
              ['Thirty Three Cows', 'Chorus', 'A', 'Major',
                [[0, 8, 76], [20, 6, 76], [9, 8, 76], [20, 5, 76], [10, 18, 76], [20, 28, 72],
                [39, 8, 74], [19, 4, 74], [10, 8, 74], [20, 6, 74], [10, 17, 74],
                [19, 26, 71], [40, 7, 72], [19, 4, 72], [10, 8, 72], [19, 5, 72],
                [10, 16, 72], [20, 29, 69], [39, 18, 70], [20, 12, 72], [10, 20, 70],
                [19, 13, 69], [10, 23, 67], [59, 19, 69], [19, 4, 72], [10, 17, 72],
                [20, 11, 69], [10, 19, 72], [19, 28, 74], [40, 8, 67], [20, 13, 67],
                [9, 18, 69], [20, 11, 68], [10, 17, 67], [19, 23, 76], [40, 7, 76],
                [19, 5, 76], [10, 8, 76], [20, 4, 76], [10, 15, 76], [19, 5, 72],
                [10, 18, 72], [20, 12, 76], [10, 17, 74]]],
              ['Thirty Three Cows', 'Verse', 'A', 'Major',
                [[0, 9, 64], [19, 8, 62], [10, 12, 60], [28, 17, 60], [31, 13, 64],
                [28, 16, 67], [17, 18, 72], [31, 14, 72], [72, 11, 71], [19, 13, 69],
                [11, 12, 67], [26, 12, 69], [30, 11, 67], [30, 16, 64], [17, 14, 62],
                [102, 11, 64], [19, 10, 62], [11, 13, 60], [27, 13, 60], [31, 11, 64],
                [28, 16, 67], [17, 17, 72], [31, 16, 72], [72, 11, 71], [18, 11, 72],
                [10, 15, 74], [29, 12, 71], [28, 13, 69], [31, 17, 71], [17, 17, 67],
                [100, 18, 64], [19, 10, 62], [10, 13, 60], [29, 15, 60], [30, 12, 64],
                [29, 17, 67], [18, 18, 72], [30, 16, 72], [71, 9, 71], [20, 13, 69],
                [12, 13, 67], [27, 12, 69], [28, 13, 67], [30, 19, 64], [18, 19, 62],
                [101, 11, 64], [18, 10, 62], [10, 15, 60], [28, 13, 60], [29, 13, 64],
                [31, 18, 72], [17, 19, 71], [31, 18, 69], [71, 12, 64], [18, 12, 62],
                [10, 14, 60], [29, 15, 60], [30, 12, 64], [29, 18, 72], [19, 17, 71],
                [29, 17, 69], [69, 19, 69], [18, 12, 69], [12, 13, 74], [30, 12, 74],
                [29, 14, 74], [31, 16, 76], [15, 59, 77]]],
              ['USSR Anthem', 'Chorus', 'C', 'Major',
                [[0, 23, 67], [23, 46, 76], [47, 35, 74], [35, 11, 72], [12, 46, 74],
                [47, 23, 71], [23, 23, 67], [24, 46, 72], [46, 35, 71], [36, 11, 69],
                [11, 46, 71], [47, 23, 64], [24, 23, 64], [23, 46, 69], [47, 23, 67],
                [23, 23, 65], [24, 46, 67], [47, 23, 60], [23, 23, 60], [24, 46, 72],
                [46, 35, 71], [36, 11, 69], [11, 93, 67]]],
              ['USSR Anthem', 'Verse', 'C', 'Major',
                [[0, 23, 67], [23, 46, 72], [47, 35, 67], [35, 11, 69], [12, 46, 71],
                [47, 23, 64], [23, 23, 64], [24, 46, 69], [46, 35, 67], [36, 11, 65],
                [11, 46, 67], [47, 23, 60], [24, 23, 60], [23, 46, 62], [47, 23, 62],
                [23, 23, 64], [24, 46, 65], [47, 23, 65], [23, 23, 67], [24, 46, 69],
                [46, 23, 71], [24, 23, 72], [23, 70, 74]]],
              ['White Ships', 'Chorus', 'G', 'Minor',
                [[0, 9, 81], [18, 9, 81], [19, 9, 81], [19, 9, 83], [19, 9, 81], [9, 9, 83],
                [9, 9, 81], [19, 18, 80], [19, 9, 76], [19, 9, 79], [18, 9, 79], [19, 9, 79],
                [19, 9, 81], [19, 9, 79], [9, 9, 81], [9, 9, 79], [19, 18, 78], [19, 9, 74],
                [19, 18, 74], [37, 28, 74], [38, 9, 73], [18, 9, 74], [19, 9, 76],
                [19, 9, 78], [19, 75, 71]]],
              ['White Ships', 'Verse', 'B', 'Minor',
                [[0, 18, 71], [28, 9, 71], [9, 9, 71], [19, 9, 74], [19, 28, 78],
                [37, 18, 76], [19, 9, 74], [19, 18, 76], [28, 9, 76], [9, 9, 76],
                [19, 9, 78], [19, 28, 76], [37, 18, 74], [19, 9, 73], [19, 28, 74],
                [37, 28, 71], [38, 28, 79], [37, 28, 76], [38, 112, 78]]],
              ['Winged Swing', 'Chorus', 'D', 'Major',
                [[0, 27, 57], [22, 37, 66], [43, 70, 66], [86, 25, 66], [22, 23, 67],
                [21, 46, 66], [43, 79, 64], [108, 21, 64], [22, 95, 71], [107, 25, 71],
                [22, 20, 69], [22, 23, 68], [21, 91, 69], [130, 54, 62], [43, 89, 74],
                [107, 20, 74], [22, 23, 72], [22, 14, 70], [21, 42, 70], [43, 88, 69],
                [108, 23, 69], [22, 23, 71], [21, 22, 69], [22, 83, 71], [84, 42, 73],
                [43, 106, 74]]],
              ['Winged Swing', 'Verse', 'D', 'Minor',
                [[0, 27, 69], [32, 8, 70], [11, 7, 69], [11, 11, 65], [10, 9, 64],
                [11, 14, 62], [11, 20, 65], [22, 36, 64], [64, 30, 69], [33, 11, 70],
                [10, 7, 69], [11, 10, 65], [11, 10, 64], [11, 16, 62], [10, 59, 64],
                [86, 29, 66], [33, 12, 67], [11, 3, 69], [10, 12, 69], [11, 11, 70],
                [11, 5, 72], [11, 23, 72], [21, 28, 70], [43, 12, 70], [11, 5, 69],
                [11, 18, 69], [21, 29, 67], [43, 12, 62], [11, 5, 64], [11, 68, 64]]],
              ['With a Smile', 'Chorus', 'C#', 'Minor',
                [[0, 14, 61], [17, 7, 64], [17, 7, 68], [17, 7, 68], [17, 7, 68], [17, 7, 68],
                [17, 20, 68], [35, 17, 73], [17, 17, 61], [17, 17, 64], [17, 8, 63],
                [17, 10, 63], [17, 10, 63], [17, 21, 63], [34, 18, 63], [17, 17, 64],
                [17, 20, 68], [17, 18, 66], [17, 16, 68], [18, 18, 69], [17, 17, 68],
                [17, 18, 66], [17, 17, 68], [17, 18, 69], [17, 34, 73], [34, 49, 71],
                [68, 15, 73], [17, 18, 68], [17, 18, 71], [17, 7, 69], [17, 5, 69],
                [17, 7, 69], [18, 23, 69], [34, 17, 73], [17, 17, 66], [17, 17, 69],
                [17, 8, 68], [17, 7, 68], [17, 7, 68], [17, 25, 68], [34, 15, 73],
                [17, 19, 64], [17, 17, 63], [17, 19, 64], [17, 18, 66], [17, 17, 69],
                [17, 15, 68], [18, 18, 66], [17, 17, 64], [17, 17, 66], [17, 37, 69],
                [34, 51, 68]]],
              ['With a Smile', 'Verse', 'B-', 'Major',
                [[0, 20, 68], [17, 20, 65], [18, 32, 70], [34, 33, 68], [34, 20, 63],
                [17, 18, 66], [17, 19, 65], [17, 19, 63], [17, 72, 61], [102, 21, 65],
                [17, 20, 68], [17, 13, 70], [18, 11, 70], [17, 18, 70], [17, 18, 72],
                [17, 20, 75], [17, 19, 73], [17, 21, 72], [17, 20, 70], [17, 38, 73],
                [34, 51, 68], [68, 19, 70], [17, 19, 72], [17, 51, 73], [51, 20, 72],
                [17, 18, 70], [17, 20, 65], [18, 19, 68], [17, 20, 66], [17, 82, 70],
                [102, 20, 72], [17, 19, 70], [17, 18, 73], [17, 18, 68], [17, 19, 72],
                [17, 10, 70], [17, 23, 70], [17, 18, 68], [17, 19, 63], [18, 19, 65],
                [17, 37, 63], [34, 41, 61]]],
              ['Wizard of Oz', 'Verse', 'F', 'Major',
                [[0, 25, 69], [30, 6, 72], [17, 5, 72], [15, 5, 77], [16, 9, 77],
                [16, 28, 81], [30, 6, 79], [16, 6, 79], [16, 15, 81], [17, 5, 79],
                [16, 5, 76], [16, 7, 72], [15, 29, 79], [31, 13, 77], [15, 14, 69],
                [17, 5, 72], [15, 6, 72], [14, 6, 77], [17, 6, 77], [16, 28, 81],
                [32, 5, 79], [15, 6, 79], [15, 12, 81], [15, 6, 79], [17, 5, 76],
                [15, 10, 72], [14, 37, 77], [48, 10, 81], [16, 24, 84], [31, 24, 84],
                [31, 24, 84], [32, 24, 84], [31, 21, 77], [28, 12, 77], [17, 62, 77],
                [62, 12, 82], [18, 22, 86], [31, 23, 86], [31, 25, 86], [31, 22, 86],
                [31, 30, 86], [33, 38, 84], [76, 8, 81], [16, 9, 84], [14, 8, 82],
                [15, 8, 77], [16, 8, 74], [15, 27, 82], [32, 27, 81], [141, 7, 72],
                [16, 19, 79], [31, 21, 79], [30, 44, 79], [48, 5, 77], [16, 63, 77]]]]

#===============================================================================

__all__ = [name for name in globals() if not name.startswith('_')]
          
#=======================================================================================================
# This is the end of constants module
#=======================================================================================================
